/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_CLOWNFISH_CLASS
#define H_CLOWNFISH_CLASS 1


#ifdef __cplusplus
extern "C" {
#endif

#include "cfish_parcel.h"

/* Include the header for this class's parent. 
 */

#include "Clownfish/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_CFISH_CLASS
extern size_t cfish_Class_IVARS_OFFSET;
typedef struct cfish_ClassIVARS cfish_ClassIVARS;
static CFISH_INLINE cfish_ClassIVARS*
cfish_Class_IVARS(cfish_Class *self) {
   char *ptr = (char*)self + cfish_Class_IVARS_OFFSET;
   return (cfish_ClassIVARS*)ptr;
}
#ifdef CFISH_USE_SHORT_NAMES
  #define ClassIVARS cfish_ClassIVARS
  #define Class_IVARS cfish_Class_IVARS
#endif

struct cfish_Class {
    CFISH_OBJ_HEAD
    cfish_Class* klass;
    cfish_Class* parent;
    cfish_String* name;
    uint32_t flags;
    int32_t parcel_id;
    size_t obj_alloc_size;
    size_t class_alloc_size;
    cfish_Method** methods;
    cfish_method_t vtable[1];
};

#endif /* C_CFISH_CLASS */

/* Declare this class's inert variables.
 */

extern CFISH_VISIBLE cfish_LockFreeRegistry* cfish_Class_registry;
extern CFISH_VISIBLE size_t cfish_Class_offset_of_parent;


/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

CFISH_VISIBLE void
cfish_Class_bootstrap(const cfish_ClassSpec* specs, size_t num_specs);

CFISH_VISIBLE cfish_Class*
cfish_Class_singleton(cfish_String* class_name, cfish_Class* parent);

CFISH_VISIBLE bool
cfish_Class_add_to_registry(cfish_Class* klass);

CFISH_VISIBLE bool
cfish_Class_add_alias_to_registry(cfish_Class* klass, const char* alias_ptr, size_t alias_len);

CFISH_VISIBLE void
cfish_Class_init_registry(void);

CFISH_VISIBLE void
cfish_Class_register_with_host(cfish_Class* klass, cfish_Class* parent);

CFISH_VISIBLE cfish_Class*
cfish_Class_fetch_class(cfish_String* class_name);

CFISH_VISIBLE cfish_String*
cfish_Class_find_parent_class(cfish_String* class_name);

CFISH_VISIBLE cfish_VArray*
cfish_Class_fresh_host_methods(cfish_String* class_name);

uint32_t
CFISH_Class_Get_RefCount_IMP(cfish_Class* self);

cfish_Obj*
CFISH_Class_Inc_RefCount_IMP(cfish_Class* self);

uint32_t
CFISH_Class_Dec_RefCount_IMP(cfish_Class* self);

void*
CFISH_Class_To_Host_IMP(cfish_Class* self);

cfish_Class*
CFISH_Class_Clone_IMP(cfish_Class* self);

void
CFISH_Class_Destroy_IMP(cfish_Class* self);

void
CFISH_Class_Override_IMP(cfish_Class* self, cfish_method_t method_ptr, size_t offset);

cfish_Obj*
CFISH_Class_Make_Obj_IMP(cfish_Class* self);

cfish_Obj*
CFISH_Class_Init_Obj_IMP(cfish_Class* self, void* allocation);

cfish_Obj*
CFISH_Class_Foster_Obj_IMP(cfish_Class* self, void* host_obj);

void
CFISH_Class_Add_Host_Method_Alias_IMP(cfish_Class* self, const char* alias, const char* meth_name);

void
CFISH_Class_Exclude_Host_Method_IMP(cfish_Class* self, const char* meth_name);

cfish_String*
CFISH_Class_Get_Name_IMP(cfish_Class* self);

cfish_Class*
CFISH_Class_Get_Parent_IMP(cfish_Class* self);

size_t
CFISH_Class_Get_Obj_Alloc_Size_IMP(cfish_Class* self);

cfish_VArray*
CFISH_Class_Get_Methods_IMP(cfish_Class* self);



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef uint32_t
(*CFISH_Class_Get_RefCount_t)(cfish_Class *self);

typedef cfish_Obj*
(*CFISH_Class_Inc_RefCount_t)(cfish_Class *self);

typedef uint32_t
(*CFISH_Class_Dec_RefCount_t)(cfish_Class *self);

typedef void*
(*CFISH_Class_To_Host_t)(cfish_Class *self);

typedef cfish_Class*
(*CFISH_Class_Clone_t)(cfish_Class *self);

typedef void
(*CFISH_Class_Destroy_t)(cfish_Class *self);

typedef bool
(*CFISH_Class_Equals_t)(cfish_Class *self, cfish_Obj* other);

typedef int32_t
(*CFISH_Class_Compare_To_t)(cfish_Class *self, cfish_Obj* other);

typedef int32_t
(*CFISH_Class_Hash_Sum_t)(cfish_Class *self);

typedef cfish_Class*
(*CFISH_Class_Get_Class_t)(cfish_Class *self);

typedef cfish_String*
(*CFISH_Class_Get_Class_Name_t)(cfish_Class *self);

typedef bool
(*CFISH_Class_Is_A_t)(cfish_Class *self, cfish_Class* ancestor);

typedef cfish_String*
(*CFISH_Class_To_String_t)(cfish_Class *self);

typedef int64_t
(*CFISH_Class_To_I64_t)(cfish_Class *self);

typedef double
(*CFISH_Class_To_F64_t)(cfish_Class *self);

typedef bool
(*CFISH_Class_To_Bool_t)(cfish_Class *self);

typedef void
(*CFISH_Class_Mimic_t)(cfish_Class *self, cfish_Obj* other);

typedef void
(*CFISH_Class_Override_t)(cfish_Class *self, cfish_method_t method_ptr, size_t offset);

typedef cfish_Obj*
(*CFISH_Class_Make_Obj_t)(cfish_Class *self);

typedef cfish_Obj*
(*CFISH_Class_Init_Obj_t)(cfish_Class *self, void* allocation);

typedef cfish_Obj*
(*CFISH_Class_Foster_Obj_t)(cfish_Class *self, void* host_obj);

typedef void
(*CFISH_Class_Add_Host_Method_Alias_t)(cfish_Class *self, const char* alias, const char* meth_name);

typedef void
(*CFISH_Class_Exclude_Host_Method_t)(cfish_Class *self, const char* meth_name);

typedef cfish_String*
(*CFISH_Class_Get_Name_t)(cfish_Class *self);

typedef cfish_Class*
(*CFISH_Class_Get_Parent_t)(cfish_Class *self);

typedef size_t
(*CFISH_Class_Get_Obj_Alloc_Size_t)(cfish_Class *self);

typedef cfish_VArray*
(*CFISH_Class_Get_Methods_t)(cfish_Class *self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern CFISH_VISIBLE size_t CFISH_Class_Get_RefCount_OFFSET;
static CFISH_INLINE uint32_t
CFISH_Class_Get_RefCount(cfish_Class *self) {
    const CFISH_Class_Get_RefCount_t method = (CFISH_Class_Get_RefCount_t)cfish_obj_method(self, CFISH_Class_Get_RefCount_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Class_Inc_RefCount_OFFSET;
static CFISH_INLINE cfish_Obj*
CFISH_Class_Inc_RefCount(cfish_Class *self) {
    const CFISH_Class_Inc_RefCount_t method = (CFISH_Class_Inc_RefCount_t)cfish_obj_method(self, CFISH_Class_Inc_RefCount_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Class_Dec_RefCount_OFFSET;
static CFISH_INLINE uint32_t
CFISH_Class_Dec_RefCount(cfish_Class *self) {
    const CFISH_Class_Dec_RefCount_t method = (CFISH_Class_Dec_RefCount_t)cfish_obj_method(self, CFISH_Class_Dec_RefCount_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Class_To_Host_OFFSET;
static CFISH_INLINE void*
CFISH_Class_To_Host(cfish_Class *self) {
    const CFISH_Class_To_Host_t method = (CFISH_Class_To_Host_t)cfish_obj_method(self, CFISH_Class_To_Host_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Class_Clone_OFFSET;
static CFISH_INLINE cfish_Class*
CFISH_Class_Clone(cfish_Class *self) {
    const CFISH_Class_Clone_t method = (CFISH_Class_Clone_t)cfish_obj_method(self, CFISH_Class_Clone_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Class_Destroy_OFFSET;
static CFISH_INLINE void
CFISH_Class_Destroy(cfish_Class *self) {
    const CFISH_Class_Destroy_t method = (CFISH_Class_Destroy_t)cfish_obj_method(self, CFISH_Class_Destroy_OFFSET);
    method(self);
}

extern CFISH_VISIBLE size_t CFISH_Class_Equals_OFFSET;
static CFISH_INLINE bool
CFISH_Class_Equals(cfish_Class *self, cfish_Obj* other) {
    const CFISH_Class_Equals_t method = (CFISH_Class_Equals_t)cfish_obj_method(self, CFISH_Class_Equals_OFFSET);
    return method(self, other);
}

extern CFISH_VISIBLE size_t CFISH_Class_Compare_To_OFFSET;
static CFISH_INLINE int32_t
CFISH_Class_Compare_To(cfish_Class *self, cfish_Obj* other) {
    const CFISH_Class_Compare_To_t method = (CFISH_Class_Compare_To_t)cfish_obj_method(self, CFISH_Class_Compare_To_OFFSET);
    return method(self, other);
}

extern CFISH_VISIBLE size_t CFISH_Class_Hash_Sum_OFFSET;
static CFISH_INLINE int32_t
CFISH_Class_Hash_Sum(cfish_Class *self) {
    const CFISH_Class_Hash_Sum_t method = (CFISH_Class_Hash_Sum_t)cfish_obj_method(self, CFISH_Class_Hash_Sum_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Class_Get_Class_OFFSET;
static CFISH_INLINE cfish_Class*
CFISH_Class_Get_Class(cfish_Class *self) {
    const CFISH_Class_Get_Class_t method = (CFISH_Class_Get_Class_t)cfish_obj_method(self, CFISH_Class_Get_Class_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Class_Get_Class_Name_OFFSET;
static CFISH_INLINE cfish_String*
CFISH_Class_Get_Class_Name(cfish_Class *self) {
    const CFISH_Class_Get_Class_Name_t method = (CFISH_Class_Get_Class_Name_t)cfish_obj_method(self, CFISH_Class_Get_Class_Name_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Class_Is_A_OFFSET;
static CFISH_INLINE bool
CFISH_Class_Is_A(cfish_Class *self, cfish_Class* ancestor) {
    const CFISH_Class_Is_A_t method = (CFISH_Class_Is_A_t)cfish_obj_method(self, CFISH_Class_Is_A_OFFSET);
    return method(self, ancestor);
}

extern CFISH_VISIBLE size_t CFISH_Class_To_String_OFFSET;
static CFISH_INLINE cfish_String*
CFISH_Class_To_String(cfish_Class *self) {
    const CFISH_Class_To_String_t method = (CFISH_Class_To_String_t)cfish_obj_method(self, CFISH_Class_To_String_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Class_To_I64_OFFSET;
static CFISH_INLINE int64_t
CFISH_Class_To_I64(cfish_Class *self) {
    const CFISH_Class_To_I64_t method = (CFISH_Class_To_I64_t)cfish_obj_method(self, CFISH_Class_To_I64_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Class_To_F64_OFFSET;
static CFISH_INLINE double
CFISH_Class_To_F64(cfish_Class *self) {
    const CFISH_Class_To_F64_t method = (CFISH_Class_To_F64_t)cfish_obj_method(self, CFISH_Class_To_F64_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Class_To_Bool_OFFSET;
static CFISH_INLINE bool
CFISH_Class_To_Bool(cfish_Class *self) {
    const CFISH_Class_To_Bool_t method = (CFISH_Class_To_Bool_t)cfish_obj_method(self, CFISH_Class_To_Bool_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Class_Mimic_OFFSET;
static CFISH_INLINE void
CFISH_Class_Mimic(cfish_Class *self, cfish_Obj* other) {
    const CFISH_Class_Mimic_t method = (CFISH_Class_Mimic_t)cfish_obj_method(self, CFISH_Class_Mimic_OFFSET);
    method(self, other);
}

extern CFISH_VISIBLE size_t CFISH_Class_Override_OFFSET;
static CFISH_INLINE void
CFISH_Class_Override(cfish_Class *self, cfish_method_t method_ptr, size_t offset) {
    const CFISH_Class_Override_t method = (CFISH_Class_Override_t)cfish_obj_method(self, CFISH_Class_Override_OFFSET);
    method(self, method_ptr, offset);
}

extern CFISH_VISIBLE size_t CFISH_Class_Make_Obj_OFFSET;
static CFISH_INLINE cfish_Obj*
CFISH_Class_Make_Obj(cfish_Class *self) {
    const CFISH_Class_Make_Obj_t method = (CFISH_Class_Make_Obj_t)cfish_obj_method(self, CFISH_Class_Make_Obj_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Class_Init_Obj_OFFSET;
static CFISH_INLINE cfish_Obj*
CFISH_Class_Init_Obj(cfish_Class *self, void* allocation) {
    const CFISH_Class_Init_Obj_t method = (CFISH_Class_Init_Obj_t)cfish_obj_method(self, CFISH_Class_Init_Obj_OFFSET);
    return method(self, allocation);
}

extern CFISH_VISIBLE size_t CFISH_Class_Foster_Obj_OFFSET;
static CFISH_INLINE cfish_Obj*
CFISH_Class_Foster_Obj(cfish_Class *self, void* host_obj) {
    const CFISH_Class_Foster_Obj_t method = (CFISH_Class_Foster_Obj_t)cfish_obj_method(self, CFISH_Class_Foster_Obj_OFFSET);
    return method(self, host_obj);
}

extern CFISH_VISIBLE size_t CFISH_Class_Add_Host_Method_Alias_OFFSET;
static CFISH_INLINE void
CFISH_Class_Add_Host_Method_Alias(cfish_Class *self, const char* alias, const char* meth_name) {
    const CFISH_Class_Add_Host_Method_Alias_t method = (CFISH_Class_Add_Host_Method_Alias_t)cfish_obj_method(self, CFISH_Class_Add_Host_Method_Alias_OFFSET);
    method(self, alias, meth_name);
}

extern CFISH_VISIBLE size_t CFISH_Class_Exclude_Host_Method_OFFSET;
static CFISH_INLINE void
CFISH_Class_Exclude_Host_Method(cfish_Class *self, const char* meth_name) {
    const CFISH_Class_Exclude_Host_Method_t method = (CFISH_Class_Exclude_Host_Method_t)cfish_obj_method(self, CFISH_Class_Exclude_Host_Method_OFFSET);
    method(self, meth_name);
}

extern CFISH_VISIBLE size_t CFISH_Class_Get_Name_OFFSET;
static CFISH_INLINE cfish_String*
CFISH_Class_Get_Name(cfish_Class *self) {
    const CFISH_Class_Get_Name_t method = (CFISH_Class_Get_Name_t)cfish_obj_method(self, CFISH_Class_Get_Name_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Class_Get_Parent_OFFSET;
static CFISH_INLINE cfish_Class*
CFISH_Class_Get_Parent(cfish_Class *self) {
    const CFISH_Class_Get_Parent_t method = (CFISH_Class_Get_Parent_t)cfish_obj_method(self, CFISH_Class_Get_Parent_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Class_Get_Obj_Alloc_Size_OFFSET;
static CFISH_INLINE size_t
CFISH_Class_Get_Obj_Alloc_Size(cfish_Class *self) {
    const CFISH_Class_Get_Obj_Alloc_Size_t method = (CFISH_Class_Get_Obj_Alloc_Size_t)cfish_obj_method(self, CFISH_Class_Get_Obj_Alloc_Size_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Class_Get_Methods_OFFSET;
static CFISH_INLINE cfish_VArray*
CFISH_Class_Get_Methods(cfish_Class *self) {
    const CFISH_Class_Get_Methods_t method = (CFISH_Class_Get_Methods_t)cfish_obj_method(self, CFISH_Class_Get_Methods_OFFSET);
    return method(self);
}



/* Declare the Class singleton for this class.
 */

extern CFISH_VISIBLE cfish_Class *CFISH_CLASS;

/* Define "short names" for this class's symbols.
 */

#ifdef CFISH_USE_SHORT_NAMES
  #define Class cfish_Class
  #define CLASS CFISH_CLASS
  #define Class_bootstrap cfish_Class_bootstrap
  #define Class_singleton cfish_Class_singleton
  #define Class_add_to_registry cfish_Class_add_to_registry
  #define Class_add_alias_to_registry cfish_Class_add_alias_to_registry
  #define Class_init_registry cfish_Class_init_registry
  #define Class_register_with_host cfish_Class_register_with_host
  #define Class_fetch_class cfish_Class_fetch_class
  #define Class_find_parent_class cfish_Class_find_parent_class
  #define Class_fresh_host_methods cfish_Class_fresh_host_methods
  #define Class_registry cfish_Class_registry
  #define Class_offset_of_parent cfish_Class_offset_of_parent
  #define Class_Get_RefCount_IMP CFISH_Class_Get_RefCount_IMP
  #define Class_Inc_RefCount_IMP CFISH_Class_Inc_RefCount_IMP
  #define Class_Dec_RefCount_IMP CFISH_Class_Dec_RefCount_IMP
  #define Class_To_Host_IMP CFISH_Class_To_Host_IMP
  #define Class_Clone_IMP CFISH_Class_Clone_IMP
  #define Class_Destroy_IMP CFISH_Class_Destroy_IMP
  #define Class_Override_IMP CFISH_Class_Override_IMP
  #define Class_Make_Obj_IMP CFISH_Class_Make_Obj_IMP
  #define Class_Init_Obj_IMP CFISH_Class_Init_Obj_IMP
  #define Class_Foster_Obj_IMP CFISH_Class_Foster_Obj_IMP
  #define Class_Add_Host_Method_Alias_IMP CFISH_Class_Add_Host_Method_Alias_IMP
  #define Class_Exclude_Host_Method_IMP CFISH_Class_Exclude_Host_Method_IMP
  #define Class_Get_Name_IMP CFISH_Class_Get_Name_IMP
  #define Class_Get_Parent_IMP CFISH_Class_Get_Parent_IMP
  #define Class_Get_Obj_Alloc_Size_IMP CFISH_Class_Get_Obj_Alloc_Size_IMP
  #define Class_Get_Methods_IMP CFISH_Class_Get_Methods_IMP
  #define Class_Get_RefCount CFISH_Class_Get_RefCount
  #define Class_Get_RefCount_t CFISH_Class_Get_RefCount_t
  #define Class_Inc_RefCount CFISH_Class_Inc_RefCount
  #define Class_Inc_RefCount_t CFISH_Class_Inc_RefCount_t
  #define Class_Dec_RefCount CFISH_Class_Dec_RefCount
  #define Class_Dec_RefCount_t CFISH_Class_Dec_RefCount_t
  #define Class_To_Host CFISH_Class_To_Host
  #define Class_To_Host_t CFISH_Class_To_Host_t
  #define Class_Clone CFISH_Class_Clone
  #define Class_Clone_t CFISH_Class_Clone_t
  #define Class_Destroy CFISH_Class_Destroy
  #define Class_Destroy_t CFISH_Class_Destroy_t
  #define Class_Equals CFISH_Class_Equals
  #define Class_Equals_t CFISH_Class_Equals_t
  #define Class_Compare_To CFISH_Class_Compare_To
  #define Class_Compare_To_t CFISH_Class_Compare_To_t
  #define Class_Hash_Sum CFISH_Class_Hash_Sum
  #define Class_Hash_Sum_t CFISH_Class_Hash_Sum_t
  #define Class_Get_Class CFISH_Class_Get_Class
  #define Class_Get_Class_t CFISH_Class_Get_Class_t
  #define Class_Get_Class_Name CFISH_Class_Get_Class_Name
  #define Class_Get_Class_Name_t CFISH_Class_Get_Class_Name_t
  #define Class_Is_A CFISH_Class_Is_A
  #define Class_Is_A_t CFISH_Class_Is_A_t
  #define Class_To_String CFISH_Class_To_String
  #define Class_To_String_t CFISH_Class_To_String_t
  #define Class_To_I64 CFISH_Class_To_I64
  #define Class_To_I64_t CFISH_Class_To_I64_t
  #define Class_To_F64 CFISH_Class_To_F64
  #define Class_To_F64_t CFISH_Class_To_F64_t
  #define Class_To_Bool CFISH_Class_To_Bool
  #define Class_To_Bool_t CFISH_Class_To_Bool_t
  #define Class_Mimic CFISH_Class_Mimic
  #define Class_Mimic_t CFISH_Class_Mimic_t
  #define Class_Override CFISH_Class_Override
  #define Class_Override_t CFISH_Class_Override_t
  #define Class_Make_Obj CFISH_Class_Make_Obj
  #define Class_Make_Obj_t CFISH_Class_Make_Obj_t
  #define Class_Init_Obj CFISH_Class_Init_Obj
  #define Class_Init_Obj_t CFISH_Class_Init_Obj_t
  #define Class_Foster_Obj CFISH_Class_Foster_Obj
  #define Class_Foster_Obj_t CFISH_Class_Foster_Obj_t
  #define Class_Add_Host_Method_Alias CFISH_Class_Add_Host_Method_Alias
  #define Class_Add_Host_Method_Alias_t CFISH_Class_Add_Host_Method_Alias_t
  #define Class_Exclude_Host_Method CFISH_Class_Exclude_Host_Method
  #define Class_Exclude_Host_Method_t CFISH_Class_Exclude_Host_Method_t
  #define Class_Get_Name CFISH_Class_Get_Name
  #define Class_Get_Name_t CFISH_Class_Get_Name_t
  #define Class_Get_Parent CFISH_Class_Get_Parent
  #define Class_Get_Parent_t CFISH_Class_Get_Parent_t
  #define Class_Get_Obj_Alloc_Size CFISH_Class_Get_Obj_Alloc_Size
  #define Class_Get_Obj_Alloc_Size_t CFISH_Class_Get_Obj_Alloc_Size_t
  #define Class_Get_Methods CFISH_Class_Get_Methods
  #define Class_Get_Methods_t CFISH_Class_Get_Methods_t
#endif /* CFISH_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_CLOWNFISH_CLASS */




