/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_CLOWNFISH_HASH
#define H_CLOWNFISH_HASH 1


#ifdef __cplusplus
extern "C" {
#endif

#include "cfish_parcel.h"

/* Include the header for this class's parent. 
 */

#include "Clownfish/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_CFISH_HASH
extern size_t cfish_Hash_IVARS_OFFSET;
typedef struct cfish_HashIVARS cfish_HashIVARS;
static CFISH_INLINE cfish_HashIVARS*
cfish_Hash_IVARS(cfish_Hash *self) {
   char *ptr = (char*)self + cfish_Hash_IVARS_OFFSET;
   return (cfish_HashIVARS*)ptr;
}
#ifdef CFISH_USE_SHORT_NAMES
  #define HashIVARS cfish_HashIVARS
  #define Hash_IVARS cfish_Hash_IVARS
#endif

struct cfish_Hash {
    CFISH_OBJ_HEAD
    cfish_Class* klass;
    void* entries;
    uint32_t capacity;
    uint32_t size;
    uint32_t threshold;
    int32_t iter_tick;
};

#endif /* C_CFISH_HASH */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

CFISH_VISIBLE void
cfish_Hash_init_class(void);

CFISH_VISIBLE cfish_Hash*
cfish_Hash_new(uint32_t capacity);

CFISH_VISIBLE cfish_Hash*
cfish_Hash_init(cfish_Hash* self, uint32_t capacity);

void
CFISH_Hash_Destroy_IMP(cfish_Hash* self);

bool
CFISH_Hash_Equals_IMP(cfish_Hash* self, cfish_Obj* other);

void
CFISH_Hash_Clear_IMP(cfish_Hash* self);

void
CFISH_Hash_Store_IMP(cfish_Hash* self, cfish_Obj* key, cfish_Obj* value);

void
CFISH_Hash_Store_Utf8_IMP(cfish_Hash* self, const char* str, size_t len, cfish_Obj* value);

cfish_Obj*
CFISH_Hash_Fetch_IMP(cfish_Hash* self, cfish_Obj* key);

cfish_Obj*
CFISH_Hash_Fetch_Utf8_IMP(cfish_Hash* self, const char* key, size_t key_len);

cfish_Obj*
CFISH_Hash_Delete_IMP(cfish_Hash* self, cfish_Obj* key);

cfish_Obj*
CFISH_Hash_Delete_Utf8_IMP(cfish_Hash* self, const char* key, size_t key_ley);

uint32_t
CFISH_Hash_Iterate_IMP(cfish_Hash* self);

bool
CFISH_Hash_Next_IMP(cfish_Hash* self, cfish_Obj** key, cfish_Obj** value);

cfish_Obj*
CFISH_Hash_Find_Key_IMP(cfish_Hash* self, cfish_Obj* key, int32_t hash_sum);

cfish_VArray*
CFISH_Hash_Keys_IMP(cfish_Hash* self);

cfish_VArray*
CFISH_Hash_Values_IMP(cfish_Hash* self);

cfish_Obj*
CFISH_Hash_Make_Key_IMP(cfish_Hash* self, cfish_Obj* key, int32_t hash_sum);

uint32_t
CFISH_Hash_Get_Capacity_IMP(cfish_Hash* self);

uint32_t
CFISH_Hash_Get_Size_IMP(cfish_Hash* self);



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef uint32_t
(*CFISH_Hash_Get_RefCount_t)(cfish_Hash *self);

typedef cfish_Obj*
(*CFISH_Hash_Inc_RefCount_t)(cfish_Hash *self);

typedef uint32_t
(*CFISH_Hash_Dec_RefCount_t)(cfish_Hash *self);

typedef void*
(*CFISH_Hash_To_Host_t)(cfish_Hash *self);

typedef cfish_Obj*
(*CFISH_Hash_Clone_t)(cfish_Hash *self);

typedef void
(*CFISH_Hash_Destroy_t)(cfish_Hash *self);

typedef bool
(*CFISH_Hash_Equals_t)(cfish_Hash *self, cfish_Obj* other);

typedef int32_t
(*CFISH_Hash_Compare_To_t)(cfish_Hash *self, cfish_Obj* other);

typedef int32_t
(*CFISH_Hash_Hash_Sum_t)(cfish_Hash *self);

typedef cfish_Class*
(*CFISH_Hash_Get_Class_t)(cfish_Hash *self);

typedef cfish_String*
(*CFISH_Hash_Get_Class_Name_t)(cfish_Hash *self);

typedef bool
(*CFISH_Hash_Is_A_t)(cfish_Hash *self, cfish_Class* ancestor);

typedef cfish_String*
(*CFISH_Hash_To_String_t)(cfish_Hash *self);

typedef int64_t
(*CFISH_Hash_To_I64_t)(cfish_Hash *self);

typedef double
(*CFISH_Hash_To_F64_t)(cfish_Hash *self);

typedef bool
(*CFISH_Hash_To_Bool_t)(cfish_Hash *self);

typedef void
(*CFISH_Hash_Mimic_t)(cfish_Hash *self, cfish_Obj* other);

typedef void
(*CFISH_Hash_Clear_t)(cfish_Hash *self);

typedef void
(*CFISH_Hash_Store_t)(cfish_Hash *self, cfish_Obj* key, cfish_Obj* value);

typedef void
(*CFISH_Hash_Store_Utf8_t)(cfish_Hash *self, const char* str, size_t len, cfish_Obj* value);

typedef cfish_Obj*
(*CFISH_Hash_Fetch_t)(cfish_Hash *self, cfish_Obj* key);

typedef cfish_Obj*
(*CFISH_Hash_Fetch_Utf8_t)(cfish_Hash *self, const char* key, size_t key_len);

typedef cfish_Obj*
(*CFISH_Hash_Delete_t)(cfish_Hash *self, cfish_Obj* key);

typedef cfish_Obj*
(*CFISH_Hash_Delete_Utf8_t)(cfish_Hash *self, const char* key, size_t key_ley);

typedef uint32_t
(*CFISH_Hash_Iterate_t)(cfish_Hash *self);

typedef bool
(*CFISH_Hash_Next_t)(cfish_Hash *self, cfish_Obj** key, cfish_Obj** value);

typedef cfish_Obj*
(*CFISH_Hash_Find_Key_t)(cfish_Hash *self, cfish_Obj* key, int32_t hash_sum);

typedef cfish_VArray*
(*CFISH_Hash_Keys_t)(cfish_Hash *self);

typedef cfish_VArray*
(*CFISH_Hash_Values_t)(cfish_Hash *self);

typedef cfish_Obj*
(*CFISH_Hash_Make_Key_t)(cfish_Hash *self, cfish_Obj* key, int32_t hash_sum);

typedef uint32_t
(*CFISH_Hash_Get_Capacity_t)(cfish_Hash *self);

typedef uint32_t
(*CFISH_Hash_Get_Size_t)(cfish_Hash *self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern CFISH_VISIBLE size_t CFISH_Hash_Get_RefCount_OFFSET;
static CFISH_INLINE uint32_t
CFISH_Hash_Get_RefCount(cfish_Hash *self) {
    const CFISH_Hash_Get_RefCount_t method = (CFISH_Hash_Get_RefCount_t)cfish_obj_method(self, CFISH_Hash_Get_RefCount_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Hash_Inc_RefCount_OFFSET;
static CFISH_INLINE cfish_Obj*
CFISH_Hash_Inc_RefCount(cfish_Hash *self) {
    const CFISH_Hash_Inc_RefCount_t method = (CFISH_Hash_Inc_RefCount_t)cfish_obj_method(self, CFISH_Hash_Inc_RefCount_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Hash_Dec_RefCount_OFFSET;
static CFISH_INLINE uint32_t
CFISH_Hash_Dec_RefCount(cfish_Hash *self) {
    const CFISH_Hash_Dec_RefCount_t method = (CFISH_Hash_Dec_RefCount_t)cfish_obj_method(self, CFISH_Hash_Dec_RefCount_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Hash_To_Host_OFFSET;
static CFISH_INLINE void*
CFISH_Hash_To_Host(cfish_Hash *self) {
    const CFISH_Hash_To_Host_t method = (CFISH_Hash_To_Host_t)cfish_obj_method(self, CFISH_Hash_To_Host_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Hash_Clone_OFFSET;
static CFISH_INLINE cfish_Obj*
CFISH_Hash_Clone(cfish_Hash *self) {
    const CFISH_Hash_Clone_t method = (CFISH_Hash_Clone_t)cfish_obj_method(self, CFISH_Hash_Clone_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Hash_Destroy_OFFSET;
static CFISH_INLINE void
CFISH_Hash_Destroy(cfish_Hash *self) {
    const CFISH_Hash_Destroy_t method = (CFISH_Hash_Destroy_t)cfish_obj_method(self, CFISH_Hash_Destroy_OFFSET);
    method(self);
}

extern CFISH_VISIBLE size_t CFISH_Hash_Equals_OFFSET;
static CFISH_INLINE bool
CFISH_Hash_Equals(cfish_Hash *self, cfish_Obj* other) {
    const CFISH_Hash_Equals_t method = (CFISH_Hash_Equals_t)cfish_obj_method(self, CFISH_Hash_Equals_OFFSET);
    return method(self, other);
}

extern CFISH_VISIBLE size_t CFISH_Hash_Compare_To_OFFSET;
static CFISH_INLINE int32_t
CFISH_Hash_Compare_To(cfish_Hash *self, cfish_Obj* other) {
    const CFISH_Hash_Compare_To_t method = (CFISH_Hash_Compare_To_t)cfish_obj_method(self, CFISH_Hash_Compare_To_OFFSET);
    return method(self, other);
}

extern CFISH_VISIBLE size_t CFISH_Hash_Hash_Sum_OFFSET;
static CFISH_INLINE int32_t
CFISH_Hash_Hash_Sum(cfish_Hash *self) {
    const CFISH_Hash_Hash_Sum_t method = (CFISH_Hash_Hash_Sum_t)cfish_obj_method(self, CFISH_Hash_Hash_Sum_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Hash_Get_Class_OFFSET;
static CFISH_INLINE cfish_Class*
CFISH_Hash_Get_Class(cfish_Hash *self) {
    const CFISH_Hash_Get_Class_t method = (CFISH_Hash_Get_Class_t)cfish_obj_method(self, CFISH_Hash_Get_Class_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Hash_Get_Class_Name_OFFSET;
static CFISH_INLINE cfish_String*
CFISH_Hash_Get_Class_Name(cfish_Hash *self) {
    const CFISH_Hash_Get_Class_Name_t method = (CFISH_Hash_Get_Class_Name_t)cfish_obj_method(self, CFISH_Hash_Get_Class_Name_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Hash_Is_A_OFFSET;
static CFISH_INLINE bool
CFISH_Hash_Is_A(cfish_Hash *self, cfish_Class* ancestor) {
    const CFISH_Hash_Is_A_t method = (CFISH_Hash_Is_A_t)cfish_obj_method(self, CFISH_Hash_Is_A_OFFSET);
    return method(self, ancestor);
}

extern CFISH_VISIBLE size_t CFISH_Hash_To_String_OFFSET;
static CFISH_INLINE cfish_String*
CFISH_Hash_To_String(cfish_Hash *self) {
    const CFISH_Hash_To_String_t method = (CFISH_Hash_To_String_t)cfish_obj_method(self, CFISH_Hash_To_String_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Hash_To_I64_OFFSET;
static CFISH_INLINE int64_t
CFISH_Hash_To_I64(cfish_Hash *self) {
    const CFISH_Hash_To_I64_t method = (CFISH_Hash_To_I64_t)cfish_obj_method(self, CFISH_Hash_To_I64_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Hash_To_F64_OFFSET;
static CFISH_INLINE double
CFISH_Hash_To_F64(cfish_Hash *self) {
    const CFISH_Hash_To_F64_t method = (CFISH_Hash_To_F64_t)cfish_obj_method(self, CFISH_Hash_To_F64_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Hash_To_Bool_OFFSET;
static CFISH_INLINE bool
CFISH_Hash_To_Bool(cfish_Hash *self) {
    const CFISH_Hash_To_Bool_t method = (CFISH_Hash_To_Bool_t)cfish_obj_method(self, CFISH_Hash_To_Bool_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Hash_Mimic_OFFSET;
static CFISH_INLINE void
CFISH_Hash_Mimic(cfish_Hash *self, cfish_Obj* other) {
    const CFISH_Hash_Mimic_t method = (CFISH_Hash_Mimic_t)cfish_obj_method(self, CFISH_Hash_Mimic_OFFSET);
    method(self, other);
}

extern CFISH_VISIBLE size_t CFISH_Hash_Clear_OFFSET;
static CFISH_INLINE void
CFISH_Hash_Clear(cfish_Hash *self) {
    const CFISH_Hash_Clear_t method = (CFISH_Hash_Clear_t)cfish_obj_method(self, CFISH_Hash_Clear_OFFSET);
    method(self);
}

extern CFISH_VISIBLE size_t CFISH_Hash_Store_OFFSET;
static CFISH_INLINE void
CFISH_Hash_Store(cfish_Hash *self, cfish_Obj* key, cfish_Obj* value) {
    const CFISH_Hash_Store_t method = (CFISH_Hash_Store_t)cfish_obj_method(self, CFISH_Hash_Store_OFFSET);
    method(self, key, value);
}

extern CFISH_VISIBLE size_t CFISH_Hash_Store_Utf8_OFFSET;
static CFISH_INLINE void
CFISH_Hash_Store_Utf8(cfish_Hash *self, const char* str, size_t len, cfish_Obj* value) {
    const CFISH_Hash_Store_Utf8_t method = (CFISH_Hash_Store_Utf8_t)cfish_obj_method(self, CFISH_Hash_Store_Utf8_OFFSET);
    method(self, str, len, value);
}

extern CFISH_VISIBLE size_t CFISH_Hash_Fetch_OFFSET;
static CFISH_INLINE cfish_Obj*
CFISH_Hash_Fetch(cfish_Hash *self, cfish_Obj* key) {
    const CFISH_Hash_Fetch_t method = (CFISH_Hash_Fetch_t)cfish_obj_method(self, CFISH_Hash_Fetch_OFFSET);
    return method(self, key);
}

extern CFISH_VISIBLE size_t CFISH_Hash_Fetch_Utf8_OFFSET;
static CFISH_INLINE cfish_Obj*
CFISH_Hash_Fetch_Utf8(cfish_Hash *self, const char* key, size_t key_len) {
    const CFISH_Hash_Fetch_Utf8_t method = (CFISH_Hash_Fetch_Utf8_t)cfish_obj_method(self, CFISH_Hash_Fetch_Utf8_OFFSET);
    return method(self, key, key_len);
}

extern CFISH_VISIBLE size_t CFISH_Hash_Delete_OFFSET;
static CFISH_INLINE cfish_Obj*
CFISH_Hash_Delete(cfish_Hash *self, cfish_Obj* key) {
    const CFISH_Hash_Delete_t method = (CFISH_Hash_Delete_t)cfish_obj_method(self, CFISH_Hash_Delete_OFFSET);
    return method(self, key);
}

extern CFISH_VISIBLE size_t CFISH_Hash_Delete_Utf8_OFFSET;
static CFISH_INLINE cfish_Obj*
CFISH_Hash_Delete_Utf8(cfish_Hash *self, const char* key, size_t key_ley) {
    const CFISH_Hash_Delete_Utf8_t method = (CFISH_Hash_Delete_Utf8_t)cfish_obj_method(self, CFISH_Hash_Delete_Utf8_OFFSET);
    return method(self, key, key_ley);
}

extern CFISH_VISIBLE size_t CFISH_Hash_Iterate_OFFSET;
static CFISH_INLINE uint32_t
CFISH_Hash_Iterate(cfish_Hash *self) {
    const CFISH_Hash_Iterate_t method = (CFISH_Hash_Iterate_t)cfish_obj_method(self, CFISH_Hash_Iterate_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Hash_Next_OFFSET;
static CFISH_INLINE bool
CFISH_Hash_Next(cfish_Hash *self, cfish_Obj** key, cfish_Obj** value) {
    const CFISH_Hash_Next_t method = (CFISH_Hash_Next_t)cfish_obj_method(self, CFISH_Hash_Next_OFFSET);
    return method(self, key, value);
}

extern CFISH_VISIBLE size_t CFISH_Hash_Find_Key_OFFSET;
static CFISH_INLINE cfish_Obj*
CFISH_Hash_Find_Key(cfish_Hash *self, cfish_Obj* key, int32_t hash_sum) {
    const CFISH_Hash_Find_Key_t method = (CFISH_Hash_Find_Key_t)cfish_obj_method(self, CFISH_Hash_Find_Key_OFFSET);
    return method(self, key, hash_sum);
}

extern CFISH_VISIBLE size_t CFISH_Hash_Keys_OFFSET;
static CFISH_INLINE cfish_VArray*
CFISH_Hash_Keys(cfish_Hash *self) {
    const CFISH_Hash_Keys_t method = (CFISH_Hash_Keys_t)cfish_obj_method(self, CFISH_Hash_Keys_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Hash_Values_OFFSET;
static CFISH_INLINE cfish_VArray*
CFISH_Hash_Values(cfish_Hash *self) {
    const CFISH_Hash_Values_t method = (CFISH_Hash_Values_t)cfish_obj_method(self, CFISH_Hash_Values_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Hash_Make_Key_OFFSET;
static CFISH_INLINE cfish_Obj*
CFISH_Hash_Make_Key(cfish_Hash *self, cfish_Obj* key, int32_t hash_sum) {
    const CFISH_Hash_Make_Key_t method = (CFISH_Hash_Make_Key_t)cfish_obj_method(self, CFISH_Hash_Make_Key_OFFSET);
    return method(self, key, hash_sum);
}

extern CFISH_VISIBLE size_t CFISH_Hash_Get_Capacity_OFFSET;
static CFISH_INLINE uint32_t
CFISH_Hash_Get_Capacity(cfish_Hash *self) {
    const CFISH_Hash_Get_Capacity_t method = (CFISH_Hash_Get_Capacity_t)cfish_obj_method(self, CFISH_Hash_Get_Capacity_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Hash_Get_Size_OFFSET;
static CFISH_INLINE uint32_t
CFISH_Hash_Get_Size(cfish_Hash *self) {
    const CFISH_Hash_Get_Size_t method = (CFISH_Hash_Get_Size_t)cfish_obj_method(self, CFISH_Hash_Get_Size_OFFSET);
    return method(self);
}



/* Declare the Class singleton for this class.
 */

extern CFISH_VISIBLE cfish_Class *CFISH_HASH;

/* Define "short names" for this class's symbols.
 */

#ifdef CFISH_USE_SHORT_NAMES
  #define Hash cfish_Hash
  #define HASH CFISH_HASH
  #define Hash_init_class cfish_Hash_init_class
  #define Hash_new cfish_Hash_new
  #define Hash_init cfish_Hash_init
  #define Hash_Destroy_IMP CFISH_Hash_Destroy_IMP
  #define Hash_Equals_IMP CFISH_Hash_Equals_IMP
  #define Hash_Clear_IMP CFISH_Hash_Clear_IMP
  #define Hash_Store_IMP CFISH_Hash_Store_IMP
  #define Hash_Store_Utf8_IMP CFISH_Hash_Store_Utf8_IMP
  #define Hash_Fetch_IMP CFISH_Hash_Fetch_IMP
  #define Hash_Fetch_Utf8_IMP CFISH_Hash_Fetch_Utf8_IMP
  #define Hash_Delete_IMP CFISH_Hash_Delete_IMP
  #define Hash_Delete_Utf8_IMP CFISH_Hash_Delete_Utf8_IMP
  #define Hash_Iterate_IMP CFISH_Hash_Iterate_IMP
  #define Hash_Next_IMP CFISH_Hash_Next_IMP
  #define Hash_Find_Key_IMP CFISH_Hash_Find_Key_IMP
  #define Hash_Keys_IMP CFISH_Hash_Keys_IMP
  #define Hash_Values_IMP CFISH_Hash_Values_IMP
  #define Hash_Make_Key_IMP CFISH_Hash_Make_Key_IMP
  #define Hash_Get_Capacity_IMP CFISH_Hash_Get_Capacity_IMP
  #define Hash_Get_Size_IMP CFISH_Hash_Get_Size_IMP
  #define Hash_Get_RefCount CFISH_Hash_Get_RefCount
  #define Hash_Get_RefCount_t CFISH_Hash_Get_RefCount_t
  #define Hash_Inc_RefCount CFISH_Hash_Inc_RefCount
  #define Hash_Inc_RefCount_t CFISH_Hash_Inc_RefCount_t
  #define Hash_Dec_RefCount CFISH_Hash_Dec_RefCount
  #define Hash_Dec_RefCount_t CFISH_Hash_Dec_RefCount_t
  #define Hash_To_Host CFISH_Hash_To_Host
  #define Hash_To_Host_t CFISH_Hash_To_Host_t
  #define Hash_Clone CFISH_Hash_Clone
  #define Hash_Clone_t CFISH_Hash_Clone_t
  #define Hash_Destroy CFISH_Hash_Destroy
  #define Hash_Destroy_t CFISH_Hash_Destroy_t
  #define Hash_Equals CFISH_Hash_Equals
  #define Hash_Equals_t CFISH_Hash_Equals_t
  #define Hash_Compare_To CFISH_Hash_Compare_To
  #define Hash_Compare_To_t CFISH_Hash_Compare_To_t
  #define Hash_Hash_Sum CFISH_Hash_Hash_Sum
  #define Hash_Hash_Sum_t CFISH_Hash_Hash_Sum_t
  #define Hash_Get_Class CFISH_Hash_Get_Class
  #define Hash_Get_Class_t CFISH_Hash_Get_Class_t
  #define Hash_Get_Class_Name CFISH_Hash_Get_Class_Name
  #define Hash_Get_Class_Name_t CFISH_Hash_Get_Class_Name_t
  #define Hash_Is_A CFISH_Hash_Is_A
  #define Hash_Is_A_t CFISH_Hash_Is_A_t
  #define Hash_To_String CFISH_Hash_To_String
  #define Hash_To_String_t CFISH_Hash_To_String_t
  #define Hash_To_I64 CFISH_Hash_To_I64
  #define Hash_To_I64_t CFISH_Hash_To_I64_t
  #define Hash_To_F64 CFISH_Hash_To_F64
  #define Hash_To_F64_t CFISH_Hash_To_F64_t
  #define Hash_To_Bool CFISH_Hash_To_Bool
  #define Hash_To_Bool_t CFISH_Hash_To_Bool_t
  #define Hash_Mimic CFISH_Hash_Mimic
  #define Hash_Mimic_t CFISH_Hash_Mimic_t
  #define Hash_Clear CFISH_Hash_Clear
  #define Hash_Clear_t CFISH_Hash_Clear_t
  #define Hash_Store CFISH_Hash_Store
  #define Hash_Store_t CFISH_Hash_Store_t
  #define Hash_Store_Utf8 CFISH_Hash_Store_Utf8
  #define Hash_Store_Utf8_t CFISH_Hash_Store_Utf8_t
  #define Hash_Fetch CFISH_Hash_Fetch
  #define Hash_Fetch_t CFISH_Hash_Fetch_t
  #define Hash_Fetch_Utf8 CFISH_Hash_Fetch_Utf8
  #define Hash_Fetch_Utf8_t CFISH_Hash_Fetch_Utf8_t
  #define Hash_Delete CFISH_Hash_Delete
  #define Hash_Delete_t CFISH_Hash_Delete_t
  #define Hash_Delete_Utf8 CFISH_Hash_Delete_Utf8
  #define Hash_Delete_Utf8_t CFISH_Hash_Delete_Utf8_t
  #define Hash_Iterate CFISH_Hash_Iterate
  #define Hash_Iterate_t CFISH_Hash_Iterate_t
  #define Hash_Next CFISH_Hash_Next
  #define Hash_Next_t CFISH_Hash_Next_t
  #define Hash_Find_Key CFISH_Hash_Find_Key
  #define Hash_Find_Key_t CFISH_Hash_Find_Key_t
  #define Hash_Keys CFISH_Hash_Keys
  #define Hash_Keys_t CFISH_Hash_Keys_t
  #define Hash_Values CFISH_Hash_Values
  #define Hash_Values_t CFISH_Hash_Values_t
  #define Hash_Make_Key CFISH_Hash_Make_Key
  #define Hash_Make_Key_t CFISH_Hash_Make_Key_t
  #define Hash_Get_Capacity CFISH_Hash_Get_Capacity
  #define Hash_Get_Capacity_t CFISH_Hash_Get_Capacity_t
  #define Hash_Get_Size CFISH_Hash_Get_Size
  #define Hash_Get_Size_t CFISH_Hash_Get_Size_t
#endif /* CFISH_USE_SHORT_NAMES */



/* Include the header for this class's parent. 
 */

#include "Clownfish/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_CFISH_HASHTOMBSTONE
extern size_t cfish_HashTombStone_IVARS_OFFSET;
typedef struct cfish_HashTombStoneIVARS cfish_HashTombStoneIVARS;
static CFISH_INLINE cfish_HashTombStoneIVARS*
cfish_HashTombStone_IVARS(cfish_HashTombStone *self) {
   char *ptr = (char*)self + cfish_HashTombStone_IVARS_OFFSET;
   return (cfish_HashTombStoneIVARS*)ptr;
}
#ifdef CFISH_USE_SHORT_NAMES
  #define HashTombStoneIVARS cfish_HashTombStoneIVARS
  #define HashTombStone_IVARS cfish_HashTombStone_IVARS
#endif

struct cfish_HashTombStone {
    CFISH_OBJ_HEAD
    cfish_Class* klass;
};

#endif /* C_CFISH_HASHTOMBSTONE */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

uint32_t
CFISH_HashTombStone_Get_RefCount_IMP(cfish_HashTombStone* self);

cfish_HashTombStone*
CFISH_HashTombStone_Inc_RefCount_IMP(cfish_HashTombStone* self);

uint32_t
CFISH_HashTombStone_Dec_RefCount_IMP(cfish_HashTombStone* self);



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef uint32_t
(*CFISH_HashTombStone_Get_RefCount_t)(cfish_HashTombStone *self);

typedef cfish_HashTombStone*
(*CFISH_HashTombStone_Inc_RefCount_t)(cfish_HashTombStone *self);

typedef uint32_t
(*CFISH_HashTombStone_Dec_RefCount_t)(cfish_HashTombStone *self);

typedef void*
(*CFISH_HashTombStone_To_Host_t)(cfish_HashTombStone *self);

typedef cfish_Obj*
(*CFISH_HashTombStone_Clone_t)(cfish_HashTombStone *self);

typedef void
(*CFISH_HashTombStone_Destroy_t)(cfish_HashTombStone *self);

typedef bool
(*CFISH_HashTombStone_Equals_t)(cfish_HashTombStone *self, cfish_Obj* other);

typedef int32_t
(*CFISH_HashTombStone_Compare_To_t)(cfish_HashTombStone *self, cfish_Obj* other);

typedef int32_t
(*CFISH_HashTombStone_Hash_Sum_t)(cfish_HashTombStone *self);

typedef cfish_Class*
(*CFISH_HashTombStone_Get_Class_t)(cfish_HashTombStone *self);

typedef cfish_String*
(*CFISH_HashTombStone_Get_Class_Name_t)(cfish_HashTombStone *self);

typedef bool
(*CFISH_HashTombStone_Is_A_t)(cfish_HashTombStone *self, cfish_Class* ancestor);

typedef cfish_String*
(*CFISH_HashTombStone_To_String_t)(cfish_HashTombStone *self);

typedef int64_t
(*CFISH_HashTombStone_To_I64_t)(cfish_HashTombStone *self);

typedef double
(*CFISH_HashTombStone_To_F64_t)(cfish_HashTombStone *self);

typedef bool
(*CFISH_HashTombStone_To_Bool_t)(cfish_HashTombStone *self);

typedef void
(*CFISH_HashTombStone_Mimic_t)(cfish_HashTombStone *self, cfish_Obj* other);



/* Define the inline functions which implement this class's virtual methods.
 */

extern CFISH_VISIBLE size_t CFISH_HashTombStone_Get_RefCount_OFFSET;
static CFISH_INLINE uint32_t
CFISH_HashTombStone_Get_RefCount(cfish_HashTombStone *self) {
    const CFISH_HashTombStone_Get_RefCount_t method = (CFISH_HashTombStone_Get_RefCount_t)cfish_obj_method(self, CFISH_HashTombStone_Get_RefCount_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_HashTombStone_Inc_RefCount_OFFSET;
static CFISH_INLINE cfish_HashTombStone*
CFISH_HashTombStone_Inc_RefCount(cfish_HashTombStone *self) {
    const CFISH_HashTombStone_Inc_RefCount_t method = (CFISH_HashTombStone_Inc_RefCount_t)cfish_obj_method(self, CFISH_HashTombStone_Inc_RefCount_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_HashTombStone_Dec_RefCount_OFFSET;
static CFISH_INLINE uint32_t
CFISH_HashTombStone_Dec_RefCount(cfish_HashTombStone *self) {
    const CFISH_HashTombStone_Dec_RefCount_t method = (CFISH_HashTombStone_Dec_RefCount_t)cfish_obj_method(self, CFISH_HashTombStone_Dec_RefCount_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_HashTombStone_To_Host_OFFSET;
static CFISH_INLINE void*
CFISH_HashTombStone_To_Host(cfish_HashTombStone *self) {
    const CFISH_HashTombStone_To_Host_t method = (CFISH_HashTombStone_To_Host_t)cfish_obj_method(self, CFISH_HashTombStone_To_Host_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_HashTombStone_Clone_OFFSET;
static CFISH_INLINE cfish_Obj*
CFISH_HashTombStone_Clone(cfish_HashTombStone *self) {
    const CFISH_HashTombStone_Clone_t method = (CFISH_HashTombStone_Clone_t)cfish_obj_method(self, CFISH_HashTombStone_Clone_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_HashTombStone_Destroy_OFFSET;
static CFISH_INLINE void
CFISH_HashTombStone_Destroy(cfish_HashTombStone *self) {
    const CFISH_HashTombStone_Destroy_t method = (CFISH_HashTombStone_Destroy_t)cfish_obj_method(self, CFISH_HashTombStone_Destroy_OFFSET);
    method(self);
}

extern CFISH_VISIBLE size_t CFISH_HashTombStone_Equals_OFFSET;
static CFISH_INLINE bool
CFISH_HashTombStone_Equals(cfish_HashTombStone *self, cfish_Obj* other) {
    const CFISH_HashTombStone_Equals_t method = (CFISH_HashTombStone_Equals_t)cfish_obj_method(self, CFISH_HashTombStone_Equals_OFFSET);
    return method(self, other);
}

extern CFISH_VISIBLE size_t CFISH_HashTombStone_Compare_To_OFFSET;
static CFISH_INLINE int32_t
CFISH_HashTombStone_Compare_To(cfish_HashTombStone *self, cfish_Obj* other) {
    const CFISH_HashTombStone_Compare_To_t method = (CFISH_HashTombStone_Compare_To_t)cfish_obj_method(self, CFISH_HashTombStone_Compare_To_OFFSET);
    return method(self, other);
}

extern CFISH_VISIBLE size_t CFISH_HashTombStone_Hash_Sum_OFFSET;
static CFISH_INLINE int32_t
CFISH_HashTombStone_Hash_Sum(cfish_HashTombStone *self) {
    const CFISH_HashTombStone_Hash_Sum_t method = (CFISH_HashTombStone_Hash_Sum_t)cfish_obj_method(self, CFISH_HashTombStone_Hash_Sum_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_HashTombStone_Get_Class_OFFSET;
static CFISH_INLINE cfish_Class*
CFISH_HashTombStone_Get_Class(cfish_HashTombStone *self) {
    const CFISH_HashTombStone_Get_Class_t method = (CFISH_HashTombStone_Get_Class_t)cfish_obj_method(self, CFISH_HashTombStone_Get_Class_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_HashTombStone_Get_Class_Name_OFFSET;
static CFISH_INLINE cfish_String*
CFISH_HashTombStone_Get_Class_Name(cfish_HashTombStone *self) {
    const CFISH_HashTombStone_Get_Class_Name_t method = (CFISH_HashTombStone_Get_Class_Name_t)cfish_obj_method(self, CFISH_HashTombStone_Get_Class_Name_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_HashTombStone_Is_A_OFFSET;
static CFISH_INLINE bool
CFISH_HashTombStone_Is_A(cfish_HashTombStone *self, cfish_Class* ancestor) {
    const CFISH_HashTombStone_Is_A_t method = (CFISH_HashTombStone_Is_A_t)cfish_obj_method(self, CFISH_HashTombStone_Is_A_OFFSET);
    return method(self, ancestor);
}

extern CFISH_VISIBLE size_t CFISH_HashTombStone_To_String_OFFSET;
static CFISH_INLINE cfish_String*
CFISH_HashTombStone_To_String(cfish_HashTombStone *self) {
    const CFISH_HashTombStone_To_String_t method = (CFISH_HashTombStone_To_String_t)cfish_obj_method(self, CFISH_HashTombStone_To_String_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_HashTombStone_To_I64_OFFSET;
static CFISH_INLINE int64_t
CFISH_HashTombStone_To_I64(cfish_HashTombStone *self) {
    const CFISH_HashTombStone_To_I64_t method = (CFISH_HashTombStone_To_I64_t)cfish_obj_method(self, CFISH_HashTombStone_To_I64_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_HashTombStone_To_F64_OFFSET;
static CFISH_INLINE double
CFISH_HashTombStone_To_F64(cfish_HashTombStone *self) {
    const CFISH_HashTombStone_To_F64_t method = (CFISH_HashTombStone_To_F64_t)cfish_obj_method(self, CFISH_HashTombStone_To_F64_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_HashTombStone_To_Bool_OFFSET;
static CFISH_INLINE bool
CFISH_HashTombStone_To_Bool(cfish_HashTombStone *self) {
    const CFISH_HashTombStone_To_Bool_t method = (CFISH_HashTombStone_To_Bool_t)cfish_obj_method(self, CFISH_HashTombStone_To_Bool_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_HashTombStone_Mimic_OFFSET;
static CFISH_INLINE void
CFISH_HashTombStone_Mimic(cfish_HashTombStone *self, cfish_Obj* other) {
    const CFISH_HashTombStone_Mimic_t method = (CFISH_HashTombStone_Mimic_t)cfish_obj_method(self, CFISH_HashTombStone_Mimic_OFFSET);
    method(self, other);
}



/* Declare the Class singleton for this class.
 */

extern CFISH_VISIBLE cfish_Class *CFISH_HASHTOMBSTONE;

/* Define "short names" for this class's symbols.
 */

#ifdef CFISH_USE_SHORT_NAMES
  #define HashTombStone cfish_HashTombStone
  #define HASHTOMBSTONE CFISH_HASHTOMBSTONE
  #define HashTombStone_Get_RefCount_IMP CFISH_HashTombStone_Get_RefCount_IMP
  #define HashTombStone_Inc_RefCount_IMP CFISH_HashTombStone_Inc_RefCount_IMP
  #define HashTombStone_Dec_RefCount_IMP CFISH_HashTombStone_Dec_RefCount_IMP
  #define HashTombStone_Get_RefCount CFISH_HashTombStone_Get_RefCount
  #define HashTombStone_Get_RefCount_t CFISH_HashTombStone_Get_RefCount_t
  #define HashTombStone_Inc_RefCount CFISH_HashTombStone_Inc_RefCount
  #define HashTombStone_Inc_RefCount_t CFISH_HashTombStone_Inc_RefCount_t
  #define HashTombStone_Dec_RefCount CFISH_HashTombStone_Dec_RefCount
  #define HashTombStone_Dec_RefCount_t CFISH_HashTombStone_Dec_RefCount_t
  #define HashTombStone_To_Host CFISH_HashTombStone_To_Host
  #define HashTombStone_To_Host_t CFISH_HashTombStone_To_Host_t
  #define HashTombStone_Clone CFISH_HashTombStone_Clone
  #define HashTombStone_Clone_t CFISH_HashTombStone_Clone_t
  #define HashTombStone_Destroy CFISH_HashTombStone_Destroy
  #define HashTombStone_Destroy_t CFISH_HashTombStone_Destroy_t
  #define HashTombStone_Equals CFISH_HashTombStone_Equals
  #define HashTombStone_Equals_t CFISH_HashTombStone_Equals_t
  #define HashTombStone_Compare_To CFISH_HashTombStone_Compare_To
  #define HashTombStone_Compare_To_t CFISH_HashTombStone_Compare_To_t
  #define HashTombStone_Hash_Sum CFISH_HashTombStone_Hash_Sum
  #define HashTombStone_Hash_Sum_t CFISH_HashTombStone_Hash_Sum_t
  #define HashTombStone_Get_Class CFISH_HashTombStone_Get_Class
  #define HashTombStone_Get_Class_t CFISH_HashTombStone_Get_Class_t
  #define HashTombStone_Get_Class_Name CFISH_HashTombStone_Get_Class_Name
  #define HashTombStone_Get_Class_Name_t CFISH_HashTombStone_Get_Class_Name_t
  #define HashTombStone_Is_A CFISH_HashTombStone_Is_A
  #define HashTombStone_Is_A_t CFISH_HashTombStone_Is_A_t
  #define HashTombStone_To_String CFISH_HashTombStone_To_String
  #define HashTombStone_To_String_t CFISH_HashTombStone_To_String_t
  #define HashTombStone_To_I64 CFISH_HashTombStone_To_I64
  #define HashTombStone_To_I64_t CFISH_HashTombStone_To_I64_t
  #define HashTombStone_To_F64 CFISH_HashTombStone_To_F64
  #define HashTombStone_To_F64_t CFISH_HashTombStone_To_F64_t
  #define HashTombStone_To_Bool CFISH_HashTombStone_To_Bool
  #define HashTombStone_To_Bool_t CFISH_HashTombStone_To_Bool_t
  #define HashTombStone_Mimic CFISH_HashTombStone_Mimic
  #define HashTombStone_Mimic_t CFISH_HashTombStone_Mimic_t
#endif /* CFISH_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_CLOWNFISH_HASH */




