/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



#ifndef H_CLOWNFISH_METHOD
#define H_CLOWNFISH_METHOD 1


#ifdef __cplusplus
extern "C" {
#endif

#include "cfish_parcel.h"

/* Include the header for this class's parent. 
 */

#include "Clownfish/Obj.h"

/* Define the struct layout for instances of this class.
 */

#ifdef C_CFISH_METHOD
extern size_t cfish_Method_IVARS_OFFSET;
typedef struct cfish_MethodIVARS cfish_MethodIVARS;
static CFISH_INLINE cfish_MethodIVARS*
cfish_Method_IVARS(cfish_Method *self) {
   char *ptr = (char*)self + cfish_Method_IVARS_OFFSET;
   return (cfish_MethodIVARS*)ptr;
}
#ifdef CFISH_USE_SHORT_NAMES
  #define MethodIVARS cfish_MethodIVARS
  #define Method_IVARS cfish_Method_IVARS
#endif

struct cfish_Method {
    CFISH_OBJ_HEAD
    cfish_Class* klass;
    cfish_String* name;
    cfish_String* host_alias;
    cfish_method_t callback_func;
    size_t offset;
    bool is_excluded;
};

#endif /* C_CFISH_METHOD */

/* Declare this class's inert variables.
 */



/* Declare both this class's inert functions and the C functions which
 * implement this class's dynamic methods.
 */

CFISH_VISIBLE cfish_Method*
cfish_Method_new(cfish_String* name, cfish_method_t callback_func, size_t offset);

CFISH_VISIBLE cfish_Method*
cfish_Method_init(cfish_Method* self, cfish_String* name, cfish_method_t callback_func, size_t offset);

uint32_t
CFISH_Method_Get_RefCount_IMP(cfish_Method* self);

cfish_Obj*
CFISH_Method_Inc_RefCount_IMP(cfish_Method* self);

uint32_t
CFISH_Method_Dec_RefCount_IMP(cfish_Method* self);

void
CFISH_Method_Destroy_IMP(cfish_Method* self);

cfish_String*
CFISH_Method_Get_Name_IMP(cfish_Method* self);

cfish_String*
CFISH_Method_Get_Host_Alias_IMP(cfish_Method* self);

bool
CFISH_Method_Is_Excluded_From_Host_IMP(cfish_Method* self);

cfish_String*
CFISH_Method_Host_Name_IMP(cfish_Method* self);



/* Define typedefs for each dynamic method, allowing us to cast generic
 * pointers to the appropriate function pointer type more cleanly.
 */

typedef uint32_t
(*CFISH_Method_Get_RefCount_t)(cfish_Method *self);

typedef cfish_Obj*
(*CFISH_Method_Inc_RefCount_t)(cfish_Method *self);

typedef uint32_t
(*CFISH_Method_Dec_RefCount_t)(cfish_Method *self);

typedef void*
(*CFISH_Method_To_Host_t)(cfish_Method *self);

typedef cfish_Obj*
(*CFISH_Method_Clone_t)(cfish_Method *self);

typedef void
(*CFISH_Method_Destroy_t)(cfish_Method *self);

typedef bool
(*CFISH_Method_Equals_t)(cfish_Method *self, cfish_Obj* other);

typedef int32_t
(*CFISH_Method_Compare_To_t)(cfish_Method *self, cfish_Obj* other);

typedef int32_t
(*CFISH_Method_Hash_Sum_t)(cfish_Method *self);

typedef cfish_Class*
(*CFISH_Method_Get_Class_t)(cfish_Method *self);

typedef cfish_String*
(*CFISH_Method_Get_Class_Name_t)(cfish_Method *self);

typedef bool
(*CFISH_Method_Is_A_t)(cfish_Method *self, cfish_Class* ancestor);

typedef cfish_String*
(*CFISH_Method_To_String_t)(cfish_Method *self);

typedef int64_t
(*CFISH_Method_To_I64_t)(cfish_Method *self);

typedef double
(*CFISH_Method_To_F64_t)(cfish_Method *self);

typedef bool
(*CFISH_Method_To_Bool_t)(cfish_Method *self);

typedef void
(*CFISH_Method_Mimic_t)(cfish_Method *self, cfish_Obj* other);

typedef cfish_String*
(*CFISH_Method_Get_Name_t)(cfish_Method *self);

typedef cfish_String*
(*CFISH_Method_Get_Host_Alias_t)(cfish_Method *self);

typedef bool
(*CFISH_Method_Is_Excluded_From_Host_t)(cfish_Method *self);

typedef cfish_String*
(*CFISH_Method_Host_Name_t)(cfish_Method *self);



/* Define the inline functions which implement this class's virtual methods.
 */

extern CFISH_VISIBLE size_t CFISH_Method_Get_RefCount_OFFSET;
static CFISH_INLINE uint32_t
CFISH_Method_Get_RefCount(cfish_Method *self) {
    const CFISH_Method_Get_RefCount_t method = (CFISH_Method_Get_RefCount_t)cfish_obj_method(self, CFISH_Method_Get_RefCount_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Method_Inc_RefCount_OFFSET;
static CFISH_INLINE cfish_Obj*
CFISH_Method_Inc_RefCount(cfish_Method *self) {
    const CFISH_Method_Inc_RefCount_t method = (CFISH_Method_Inc_RefCount_t)cfish_obj_method(self, CFISH_Method_Inc_RefCount_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Method_Dec_RefCount_OFFSET;
static CFISH_INLINE uint32_t
CFISH_Method_Dec_RefCount(cfish_Method *self) {
    const CFISH_Method_Dec_RefCount_t method = (CFISH_Method_Dec_RefCount_t)cfish_obj_method(self, CFISH_Method_Dec_RefCount_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Method_To_Host_OFFSET;
static CFISH_INLINE void*
CFISH_Method_To_Host(cfish_Method *self) {
    const CFISH_Method_To_Host_t method = (CFISH_Method_To_Host_t)cfish_obj_method(self, CFISH_Method_To_Host_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Method_Clone_OFFSET;
static CFISH_INLINE cfish_Obj*
CFISH_Method_Clone(cfish_Method *self) {
    const CFISH_Method_Clone_t method = (CFISH_Method_Clone_t)cfish_obj_method(self, CFISH_Method_Clone_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Method_Destroy_OFFSET;
static CFISH_INLINE void
CFISH_Method_Destroy(cfish_Method *self) {
    const CFISH_Method_Destroy_t method = (CFISH_Method_Destroy_t)cfish_obj_method(self, CFISH_Method_Destroy_OFFSET);
    method(self);
}

extern CFISH_VISIBLE size_t CFISH_Method_Equals_OFFSET;
static CFISH_INLINE bool
CFISH_Method_Equals(cfish_Method *self, cfish_Obj* other) {
    const CFISH_Method_Equals_t method = (CFISH_Method_Equals_t)cfish_obj_method(self, CFISH_Method_Equals_OFFSET);
    return method(self, other);
}

extern CFISH_VISIBLE size_t CFISH_Method_Compare_To_OFFSET;
static CFISH_INLINE int32_t
CFISH_Method_Compare_To(cfish_Method *self, cfish_Obj* other) {
    const CFISH_Method_Compare_To_t method = (CFISH_Method_Compare_To_t)cfish_obj_method(self, CFISH_Method_Compare_To_OFFSET);
    return method(self, other);
}

extern CFISH_VISIBLE size_t CFISH_Method_Hash_Sum_OFFSET;
static CFISH_INLINE int32_t
CFISH_Method_Hash_Sum(cfish_Method *self) {
    const CFISH_Method_Hash_Sum_t method = (CFISH_Method_Hash_Sum_t)cfish_obj_method(self, CFISH_Method_Hash_Sum_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Method_Get_Class_OFFSET;
static CFISH_INLINE cfish_Class*
CFISH_Method_Get_Class(cfish_Method *self) {
    const CFISH_Method_Get_Class_t method = (CFISH_Method_Get_Class_t)cfish_obj_method(self, CFISH_Method_Get_Class_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Method_Get_Class_Name_OFFSET;
static CFISH_INLINE cfish_String*
CFISH_Method_Get_Class_Name(cfish_Method *self) {
    const CFISH_Method_Get_Class_Name_t method = (CFISH_Method_Get_Class_Name_t)cfish_obj_method(self, CFISH_Method_Get_Class_Name_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Method_Is_A_OFFSET;
static CFISH_INLINE bool
CFISH_Method_Is_A(cfish_Method *self, cfish_Class* ancestor) {
    const CFISH_Method_Is_A_t method = (CFISH_Method_Is_A_t)cfish_obj_method(self, CFISH_Method_Is_A_OFFSET);
    return method(self, ancestor);
}

extern CFISH_VISIBLE size_t CFISH_Method_To_String_OFFSET;
static CFISH_INLINE cfish_String*
CFISH_Method_To_String(cfish_Method *self) {
    const CFISH_Method_To_String_t method = (CFISH_Method_To_String_t)cfish_obj_method(self, CFISH_Method_To_String_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Method_To_I64_OFFSET;
static CFISH_INLINE int64_t
CFISH_Method_To_I64(cfish_Method *self) {
    const CFISH_Method_To_I64_t method = (CFISH_Method_To_I64_t)cfish_obj_method(self, CFISH_Method_To_I64_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Method_To_F64_OFFSET;
static CFISH_INLINE double
CFISH_Method_To_F64(cfish_Method *self) {
    const CFISH_Method_To_F64_t method = (CFISH_Method_To_F64_t)cfish_obj_method(self, CFISH_Method_To_F64_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Method_To_Bool_OFFSET;
static CFISH_INLINE bool
CFISH_Method_To_Bool(cfish_Method *self) {
    const CFISH_Method_To_Bool_t method = (CFISH_Method_To_Bool_t)cfish_obj_method(self, CFISH_Method_To_Bool_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Method_Mimic_OFFSET;
static CFISH_INLINE void
CFISH_Method_Mimic(cfish_Method *self, cfish_Obj* other) {
    const CFISH_Method_Mimic_t method = (CFISH_Method_Mimic_t)cfish_obj_method(self, CFISH_Method_Mimic_OFFSET);
    method(self, other);
}

extern CFISH_VISIBLE size_t CFISH_Method_Get_Name_OFFSET;
static CFISH_INLINE cfish_String*
CFISH_Method_Get_Name(cfish_Method *self) {
    const CFISH_Method_Get_Name_t method = (CFISH_Method_Get_Name_t)cfish_obj_method(self, CFISH_Method_Get_Name_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Method_Get_Host_Alias_OFFSET;
static CFISH_INLINE cfish_String*
CFISH_Method_Get_Host_Alias(cfish_Method *self) {
    const CFISH_Method_Get_Host_Alias_t method = (CFISH_Method_Get_Host_Alias_t)cfish_obj_method(self, CFISH_Method_Get_Host_Alias_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Method_Is_Excluded_From_Host_OFFSET;
static CFISH_INLINE bool
CFISH_Method_Is_Excluded_From_Host(cfish_Method *self) {
    const CFISH_Method_Is_Excluded_From_Host_t method = (CFISH_Method_Is_Excluded_From_Host_t)cfish_obj_method(self, CFISH_Method_Is_Excluded_From_Host_OFFSET);
    return method(self);
}

extern CFISH_VISIBLE size_t CFISH_Method_Host_Name_OFFSET;
static CFISH_INLINE cfish_String*
CFISH_Method_Host_Name(cfish_Method *self) {
    const CFISH_Method_Host_Name_t method = (CFISH_Method_Host_Name_t)cfish_obj_method(self, CFISH_Method_Host_Name_OFFSET);
    return method(self);
}



/* Declare the Class singleton for this class.
 */

extern CFISH_VISIBLE cfish_Class *CFISH_METHOD;

/* Define "short names" for this class's symbols.
 */

#ifdef CFISH_USE_SHORT_NAMES
  #define Method cfish_Method
  #define METHOD CFISH_METHOD
  #define Method_new cfish_Method_new
  #define Method_init cfish_Method_init
  #define Method_Get_RefCount_IMP CFISH_Method_Get_RefCount_IMP
  #define Method_Inc_RefCount_IMP CFISH_Method_Inc_RefCount_IMP
  #define Method_Dec_RefCount_IMP CFISH_Method_Dec_RefCount_IMP
  #define Method_Destroy_IMP CFISH_Method_Destroy_IMP
  #define Method_Get_Name_IMP CFISH_Method_Get_Name_IMP
  #define Method_Get_Host_Alias_IMP CFISH_Method_Get_Host_Alias_IMP
  #define Method_Is_Excluded_From_Host_IMP CFISH_Method_Is_Excluded_From_Host_IMP
  #define Method_Host_Name_IMP CFISH_Method_Host_Name_IMP
  #define Method_Get_RefCount CFISH_Method_Get_RefCount
  #define Method_Get_RefCount_t CFISH_Method_Get_RefCount_t
  #define Method_Inc_RefCount CFISH_Method_Inc_RefCount
  #define Method_Inc_RefCount_t CFISH_Method_Inc_RefCount_t
  #define Method_Dec_RefCount CFISH_Method_Dec_RefCount
  #define Method_Dec_RefCount_t CFISH_Method_Dec_RefCount_t
  #define Method_To_Host CFISH_Method_To_Host
  #define Method_To_Host_t CFISH_Method_To_Host_t
  #define Method_Clone CFISH_Method_Clone
  #define Method_Clone_t CFISH_Method_Clone_t
  #define Method_Destroy CFISH_Method_Destroy
  #define Method_Destroy_t CFISH_Method_Destroy_t
  #define Method_Equals CFISH_Method_Equals
  #define Method_Equals_t CFISH_Method_Equals_t
  #define Method_Compare_To CFISH_Method_Compare_To
  #define Method_Compare_To_t CFISH_Method_Compare_To_t
  #define Method_Hash_Sum CFISH_Method_Hash_Sum
  #define Method_Hash_Sum_t CFISH_Method_Hash_Sum_t
  #define Method_Get_Class CFISH_Method_Get_Class
  #define Method_Get_Class_t CFISH_Method_Get_Class_t
  #define Method_Get_Class_Name CFISH_Method_Get_Class_Name
  #define Method_Get_Class_Name_t CFISH_Method_Get_Class_Name_t
  #define Method_Is_A CFISH_Method_Is_A
  #define Method_Is_A_t CFISH_Method_Is_A_t
  #define Method_To_String CFISH_Method_To_String
  #define Method_To_String_t CFISH_Method_To_String_t
  #define Method_To_I64 CFISH_Method_To_I64
  #define Method_To_I64_t CFISH_Method_To_I64_t
  #define Method_To_F64 CFISH_Method_To_F64
  #define Method_To_F64_t CFISH_Method_To_F64_t
  #define Method_To_Bool CFISH_Method_To_Bool
  #define Method_To_Bool_t CFISH_Method_To_Bool_t
  #define Method_Mimic CFISH_Method_Mimic
  #define Method_Mimic_t CFISH_Method_Mimic_t
  #define Method_Get_Name CFISH_Method_Get_Name
  #define Method_Get_Name_t CFISH_Method_Get_Name_t
  #define Method_Get_Host_Alias CFISH_Method_Get_Host_Alias
  #define Method_Get_Host_Alias_t CFISH_Method_Get_Host_Alias_t
  #define Method_Is_Excluded_From_Host CFISH_Method_Is_Excluded_From_Host
  #define Method_Is_Excluded_From_Host_t CFISH_Method_Is_Excluded_From_Host_t
  #define Method_Host_Name CFISH_Method_Host_Name
  #define Method_Host_Name_t CFISH_Method_Host_Name_t
#endif /* CFISH_USE_SHORT_NAMES */





#ifdef __cplusplus
}
#endif

#endif /* H_CLOWNFISH_METHOD */




