/***********************************************

 !!!! DO NOT EDIT !!!!

 This file was auto-generated by Build.PL.

 ***********************************************/

/* Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


#include "XSBind.h"
#include "callbacks.h"

static void
S_finish_callback_void(const char *meth_name) {
    int count = call_method(meth_name, G_VOID | G_DISCARD);
    if (count != 0) {
        CFISH_THROW(CFISH_ERR, "Bad callback to '%s': %i32",
                    meth_name, (int32_t)count);
    }
    FREETMPS;
    LEAVE;
}

static CFISH_INLINE SV*
SI_do_callback_sv(const char *meth_name) {
    int count = call_method(meth_name, G_SCALAR);
    if (count != 1) {
        CFISH_THROW(CFISH_ERR, "Bad callback to '%s': %i32",
                    meth_name, (int32_t)count);
    }
    dSP;
    SV *return_sv = POPs;
    PUTBACK;
    return return_sv;
}

static int64_t
S_finish_callback_i64(const char *meth_name) {
    SV *return_sv = SI_do_callback_sv(meth_name);
    int64_t retval;
    if (sizeof(IV) == 8) {
        retval = (int64_t)SvIV(return_sv);
    }
    else {
        if (SvIOK(return_sv)) {
            // It's already no more than 32 bits, so don't convert.
            retval = SvIV(return_sv);
        }
        else {
            // Maybe lossy.
            double temp = SvNV(return_sv);
            retval = (int64_t)temp;
        }
    }
    FREETMPS;
    LEAVE;
    return retval;
}

static double
S_finish_callback_f64(const char *meth_name) {
    SV *return_sv = SI_do_callback_sv(meth_name);
    double retval = SvNV(return_sv);
    FREETMPS;
    LEAVE;
    return retval;
}

static cfish_Obj*
S_finish_callback_obj(void *vself, const char *meth_name,
                      int nullable) {
    SV *return_sv = SI_do_callback_sv(meth_name);
    cfish_Obj *retval = XSBind_perl_to_cfish(return_sv);
    FREETMPS;
    LEAVE;
    if (!nullable && !retval) {
        CFISH_THROW(CFISH_ERR, "%o#%s cannot return NULL",
                    CFISH_Obj_Get_Class_Name((cfish_Obj*)vself),
                    meth_name);
    }
    return retval;
}

uint32_t
Cfish_Obj_Get_RefCount_OVERRIDE(cfish_Obj* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    uint32_t retval = (uint32_t)S_finish_callback_i64("get_refcount");
    return retval;
}

cfish_Obj*
Cfish_Obj_Inc_RefCount_OVERRIDE(cfish_Obj* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    cfish_Obj* retval = (cfish_Obj*)S_finish_callback_obj(self, "inc_refcount", false);
    return retval;
}

uint32_t
Cfish_Obj_Dec_RefCount_OVERRIDE(cfish_Obj* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    uint32_t retval = (uint32_t)S_finish_callback_i64("dec_refcount");
    return retval;
}

void*
Cfish_Obj_To_Host_OVERRIDE(cfish_Obj* self) {
    CFISH_UNUSED_VAR(self);
    CFISH_THROW(CFISH_ERR, "Can't override CFISH_Obj_To_Host via binding");
    CFISH_UNREACHABLE_RETURN(void*);
}

cfish_Obj*
Cfish_Obj_Clone_OVERRIDE(cfish_Obj* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    cfish_Obj* retval = (cfish_Obj*)S_finish_callback_obj(self, "clone", false);
    return retval;
}

void
Cfish_Obj_Destroy_OVERRIDE(cfish_Obj* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    S_finish_callback_void("DESTROY");
}

bool
Cfish_Obj_Equals_OVERRIDE(cfish_Obj* self, cfish_Obj* other) {
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    mPUSHs(XSBind_cfish_to_perl((cfish_Obj*)other));
    PUTBACK;
    bool retval = (bool)!!S_finish_callback_i64("equals");
    return retval;
}

int32_t
Cfish_Obj_Compare_To_OVERRIDE(cfish_Obj* self, cfish_Obj* other) {
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    mPUSHs(XSBind_cfish_to_perl((cfish_Obj*)other));
    PUTBACK;
    int32_t retval = (int32_t)S_finish_callback_i64("compare_to");
    return retval;
}

int32_t
Cfish_Obj_Hash_Sum_OVERRIDE(cfish_Obj* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    int32_t retval = (int32_t)S_finish_callback_i64("hash_sum");
    return retval;
}

cfish_Class*
Cfish_Obj_Get_Class_OVERRIDE(cfish_Obj* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    cfish_Class* retval = (cfish_Class*)S_finish_callback_obj(self, "get_class", false);
    CFISH_DECREF(retval);
    return retval;
}

cfish_String*
Cfish_Obj_Get_Class_Name_OVERRIDE(cfish_Obj* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    cfish_String* retval = (cfish_String*)S_finish_callback_obj(self, "get_class_name", false);
    CFISH_DECREF(retval);
    return retval;
}

bool
Cfish_Obj_Is_A_OVERRIDE(cfish_Obj* self, cfish_Class* ancestor) {
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    mPUSHs(XSBind_cfish_to_perl((cfish_Obj*)ancestor));
    PUTBACK;
    bool retval = (bool)!!S_finish_callback_i64("is_a");
    return retval;
}

cfish_String*
Cfish_Obj_To_String_OVERRIDE(cfish_Obj* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    cfish_String* retval = (cfish_String*)S_finish_callback_obj(self, "to_string", false);
    return retval;
}

int64_t
Cfish_Obj_To_I64_OVERRIDE(cfish_Obj* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    int64_t retval = (int64_t)S_finish_callback_i64("to_i64");
    return retval;
}

double
Cfish_Obj_To_F64_OVERRIDE(cfish_Obj* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    double retval = (double)S_finish_callback_f64("to_f64");
    return retval;
}

bool
Cfish_Obj_To_Bool_OVERRIDE(cfish_Obj* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    bool retval = (bool)!!S_finish_callback_i64("to_bool");
    return retval;
}

void
Cfish_Obj_Mimic_OVERRIDE(cfish_Obj* self, cfish_Obj* other) {
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    mPUSHs(XSBind_cfish_to_perl((cfish_Obj*)other));
    PUTBACK;
    S_finish_callback_void("mimic");
}

void
Cfish_Float32_Set_Value_OVERRIDE(cfish_Float32* self, float value) {
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    mPUSHn(value);
    PUTBACK;
    S_finish_callback_void("set_value");
}

float
Cfish_Float32_Get_Value_OVERRIDE(cfish_Float32* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    float retval = (float)S_finish_callback_f64("get_value");
    return retval;
}

void
Cfish_Float64_Set_Value_OVERRIDE(cfish_Float64* self, double value) {
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    mPUSHn(value);
    PUTBACK;
    S_finish_callback_void("set_value");
}

double
Cfish_Float64_Get_Value_OVERRIDE(cfish_Float64* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    double retval = (double)S_finish_callback_f64("get_value");
    return retval;
}

void
Cfish_Int32_Set_Value_OVERRIDE(cfish_Integer32* self, int32_t value) {
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    mPUSHi(value);
    PUTBACK;
    S_finish_callback_void("set_value");
}

int32_t
Cfish_Int32_Get_Value_OVERRIDE(cfish_Integer32* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    int32_t retval = (int32_t)S_finish_callback_i64("get_value");
    return retval;
}

void
Cfish_Int64_Set_Value_OVERRIDE(cfish_Integer64* self, int64_t value) {
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    if (sizeof(IV) >= sizeof(int64_t)) { mPUSHi(value); }
    else { mPUSHn((double)value); } // lossy 
    PUTBACK;
    S_finish_callback_void("set_value");
}

int64_t
Cfish_Int64_Get_Value_OVERRIDE(cfish_Integer64* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    int64_t retval = (int64_t)S_finish_callback_i64("get_value");
    return retval;
}

bool
Cfish_Bool_Get_Value_OVERRIDE(cfish_BoolNum* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    bool retval = (bool)!!S_finish_callback_i64("get_value");
    return retval;
}

bool
Cfish_TestSuiteRunner_Run_Batch_OVERRIDE(cfish_TestSuiteRunner* self, cfish_TestBatch* batch) {
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    mPUSHs(XSBind_cfish_to_perl((cfish_Obj*)batch));
    PUTBACK;
    bool retval = (bool)!!S_finish_callback_i64("run_batch");
    return retval;
}

bool
Cfish_TestSuiteRunner_Finish_OVERRIDE(cfish_TestSuiteRunner* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    bool retval = (bool)!!S_finish_callback_i64("finish");
    return retval;
}

uint32_t
Cfish_TestSuiteRunner_Get_Num_Tests_OVERRIDE(cfish_TestSuiteRunner* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    uint32_t retval = (uint32_t)S_finish_callback_i64("get_num_tests");
    return retval;
}

uint32_t
Cfish_TestSuiteRunner_Get_Num_Tests_Failed_OVERRIDE(cfish_TestSuiteRunner* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    uint32_t retval = (uint32_t)S_finish_callback_i64("get_num_tests_failed");
    return retval;
}

uint32_t
Cfish_TestSuiteRunner_Get_Num_Batches_OVERRIDE(cfish_TestSuiteRunner* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    uint32_t retval = (uint32_t)S_finish_callback_i64("get_num_batches");
    return retval;
}

uint32_t
Cfish_TestSuiteRunner_Get_Num_Batches_Failed_OVERRIDE(cfish_TestSuiteRunner* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    uint32_t retval = (uint32_t)S_finish_callback_i64("get_num_batches_failed");
    return retval;
}

bool
Cfish_TestBatchRunner_Run_Batch_OVERRIDE(cfish_TestBatchRunner* self, cfish_TestBatch* batch) {
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    mPUSHs(XSBind_cfish_to_perl((cfish_Obj*)batch));
    PUTBACK;
    bool retval = (bool)!!S_finish_callback_i64("run_batch");
    return retval;
}

void
Cfish_TestBatchRunner_Plan_OVERRIDE(cfish_TestBatchRunner* self, cfish_TestBatch* batch, uint32_t num_planned) {
    dSP;
    EXTEND(SP, 5);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    mPUSHp("batch", 5);
    mPUSHs(XSBind_cfish_to_perl((cfish_Obj*)batch));
    mPUSHp("num_planned", 11);
    mPUSHi(num_planned);
    PUTBACK;
    S_finish_callback_void("plan");
}

uint32_t
Cfish_TestBatchRunner_Get_Num_Planned_OVERRIDE(cfish_TestBatchRunner* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    uint32_t retval = (uint32_t)S_finish_callback_i64("get_num_planned");
    return retval;
}

uint32_t
Cfish_TestBatchRunner_Get_Num_Tests_OVERRIDE(cfish_TestBatchRunner* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    uint32_t retval = (uint32_t)S_finish_callback_i64("get_num_tests");
    return retval;
}

uint32_t
Cfish_TestBatchRunner_Get_Num_Failed_OVERRIDE(cfish_TestBatchRunner* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    uint32_t retval = (uint32_t)S_finish_callback_i64("get_num_failed");
    return retval;
}

bool
Cfish_TestBatchRunner_VTest_True_OVERRIDE(cfish_TestBatchRunner* self, bool condition, const char* pattern, va_list args) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(condition);
    CFISH_UNUSED_VAR(pattern);
    CFISH_UNUSED_VAR(args);
    CFISH_THROW(CFISH_ERR, "Can't override CFISH_TestBatchRunner_VTest_True via binding");
    CFISH_UNREACHABLE_RETURN(bool);
}

bool
Cfish_TestBatchRunner_VTest_False_OVERRIDE(cfish_TestBatchRunner* self, bool condition, const char* pattern, va_list args) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(condition);
    CFISH_UNUSED_VAR(pattern);
    CFISH_UNUSED_VAR(args);
    CFISH_THROW(CFISH_ERR, "Can't override CFISH_TestBatchRunner_VTest_False via binding");
    CFISH_UNREACHABLE_RETURN(bool);
}

bool
Cfish_TestBatchRunner_VTest_Int_Equals_OVERRIDE(cfish_TestBatchRunner* self, long got, long expected, const char* pattern, va_list args) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(got);
    CFISH_UNUSED_VAR(expected);
    CFISH_UNUSED_VAR(pattern);
    CFISH_UNUSED_VAR(args);
    CFISH_THROW(CFISH_ERR, "Can't override CFISH_TestBatchRunner_VTest_Int_Equals via binding");
    CFISH_UNREACHABLE_RETURN(bool);
}

bool
Cfish_TestBatchRunner_VTest_Float_Equals_OVERRIDE(cfish_TestBatchRunner* self, double got, double expected, const char* pattern, va_list args) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(got);
    CFISH_UNUSED_VAR(expected);
    CFISH_UNUSED_VAR(pattern);
    CFISH_UNUSED_VAR(args);
    CFISH_THROW(CFISH_ERR, "Can't override CFISH_TestBatchRunner_VTest_Float_Equals via binding");
    CFISH_UNREACHABLE_RETURN(bool);
}

bool
Cfish_TestBatchRunner_VTest_String_Equals_OVERRIDE(cfish_TestBatchRunner* self, const char* got, const char* expected, const char* pattern, va_list args) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(got);
    CFISH_UNUSED_VAR(expected);
    CFISH_UNUSED_VAR(pattern);
    CFISH_UNUSED_VAR(args);
    CFISH_THROW(CFISH_ERR, "Can't override CFISH_TestBatchRunner_VTest_String_Equals via binding");
    CFISH_UNREACHABLE_RETURN(bool);
}

bool
Cfish_TestBatchRunner_VPass_OVERRIDE(cfish_TestBatchRunner* self, const char* pattern, va_list args) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(pattern);
    CFISH_UNUSED_VAR(args);
    CFISH_THROW(CFISH_ERR, "Can't override CFISH_TestBatchRunner_VPass via binding");
    CFISH_UNREACHABLE_RETURN(bool);
}

bool
Cfish_TestBatchRunner_VFail_OVERRIDE(cfish_TestBatchRunner* self, const char* pattern, va_list args) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(pattern);
    CFISH_UNUSED_VAR(args);
    CFISH_THROW(CFISH_ERR, "Can't override CFISH_TestBatchRunner_VFail via binding");
    CFISH_UNREACHABLE_RETURN(bool);
}

void
Cfish_TestBatchRunner_VSkip_OVERRIDE(cfish_TestBatchRunner* self, const char* pattern, va_list args) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(pattern);
    CFISH_UNUSED_VAR(args);
    CFISH_THROW(CFISH_ERR, "Can't override CFISH_TestBatchRunner_VSkip via binding");
}

void
Cfish_TestFormatter_Batch_Prologue_OVERRIDE(cfish_TestFormatter* self, cfish_TestBatch* batch, uint32_t num_planned) {
    dSP;
    EXTEND(SP, 5);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    mPUSHp("batch", 5);
    mPUSHs(XSBind_cfish_to_perl((cfish_Obj*)batch));
    mPUSHp("num_planned", 11);
    mPUSHi(num_planned);
    PUTBACK;
    S_finish_callback_void("batch_prologue");
}

void
Cfish_TestFormatter_VTest_Result_OVERRIDE(cfish_TestFormatter* self, bool pass, uint32_t test_num, const char* fmt, va_list args) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(pass);
    CFISH_UNUSED_VAR(test_num);
    CFISH_UNUSED_VAR(fmt);
    CFISH_UNUSED_VAR(args);
    CFISH_THROW(CFISH_ERR, "Can't override CFISH_TestFormatter_VTest_Result via binding");
}

void
Cfish_TestFormatter_VTest_Comment_OVERRIDE(cfish_TestFormatter* self, const char* fmt, va_list args) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(fmt);
    CFISH_UNUSED_VAR(args);
    CFISH_THROW(CFISH_ERR, "Can't override CFISH_TestFormatter_VTest_Comment via binding");
}

void
Cfish_TestFormatter_VBatch_Comment_OVERRIDE(cfish_TestFormatter* self, const char* fmt, va_list args) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(fmt);
    CFISH_UNUSED_VAR(args);
    CFISH_THROW(CFISH_ERR, "Can't override CFISH_TestFormatter_VBatch_Comment via binding");
}

void
Cfish_TestFormatter_Summary_OVERRIDE(cfish_TestFormatter* self, cfish_TestSuiteRunner* runner) {
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    mPUSHs(XSBind_cfish_to_perl((cfish_Obj*)runner));
    PUTBACK;
    S_finish_callback_void("summary");
}

void
Cfish_TestBatch_Run_OVERRIDE(cfish_TestBatch* self, cfish_TestBatchRunner* runner) {
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    mPUSHs(XSBind_cfish_to_perl((cfish_Obj*)runner));
    PUTBACK;
    S_finish_callback_void("run");
}

void
Cfish_TestSuite_Add_Batch_OVERRIDE(cfish_TestSuite* self, cfish_TestBatch* batch) {
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    mPUSHs(XSBind_cfish_to_perl((cfish_Obj*)batch));
    PUTBACK;
    S_finish_callback_void("add_batch");
    CFISH_DECREF(batch);
}

bool
Cfish_TestSuite_Run_Batch_OVERRIDE(cfish_TestSuite* self, cfish_String* class_name, cfish_TestFormatter* formatter) {
    dSP;
    EXTEND(SP, 5);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    mPUSHp("class_name", 10);
    mPUSHs(XSBind_str_to_sv((cfish_String*)class_name));
    mPUSHp("formatter", 9);
    mPUSHs(XSBind_cfish_to_perl((cfish_Obj*)formatter));
    PUTBACK;
    bool retval = (bool)!!S_finish_callback_i64("run_batch");
    return retval;
}

bool
Cfish_TestSuite_Run_All_Batches_OVERRIDE(cfish_TestSuite* self, cfish_TestFormatter* formatter) {
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    mPUSHs(XSBind_cfish_to_perl((cfish_Obj*)formatter));
    PUTBACK;
    bool retval = (bool)!!S_finish_callback_i64("run_all_batches");
    return retval;
}

cfish_String*
Cfish_Str_Cat_OVERRIDE(cfish_String* self, cfish_String* other) {
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    mPUSHs(XSBind_str_to_sv((cfish_String*)other));
    PUTBACK;
    cfish_String* retval = (cfish_String*)S_finish_callback_obj(self, "cat", false);
    return retval;
}

cfish_String*
Cfish_Str_Cat_Utf8_OVERRIDE(cfish_String* self, const char* ptr, size_t size) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(ptr);
    CFISH_UNUSED_VAR(size);
    CFISH_THROW(CFISH_ERR, "Can't override CFISH_Str_Cat_Utf8 via binding");
    CFISH_UNREACHABLE_RETURN(cfish_String*);
}

cfish_String*
Cfish_Str_Cat_Trusted_Utf8_OVERRIDE(cfish_String* self, const char* ptr, size_t size) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(ptr);
    CFISH_UNUSED_VAR(size);
    CFISH_THROW(CFISH_ERR, "Can't override CFISH_Str_Cat_Trusted_Utf8 via binding");
    CFISH_UNREACHABLE_RETURN(cfish_String*);
}

cfish_String*
Cfish_Str_Swap_Chars_OVERRIDE(cfish_String* self, int32_t match, int32_t replacement) {
    dSP;
    EXTEND(SP, 5);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    mPUSHp("match", 5);
    mPUSHi(match);
    mPUSHp("replacement", 11);
    mPUSHi(replacement);
    PUTBACK;
    cfish_String* retval = (cfish_String*)S_finish_callback_obj(self, "swap_chars", false);
    return retval;
}

int64_t
Cfish_Str_BaseX_To_I64_OVERRIDE(cfish_String* self, uint32_t base) {
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    mPUSHi(base);
    PUTBACK;
    int64_t retval = (int64_t)S_finish_callback_i64("basex_to_i64");
    return retval;
}

bool
Cfish_Str_Starts_With_OVERRIDE(cfish_String* self, cfish_String* prefix) {
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    mPUSHs(XSBind_str_to_sv((cfish_String*)prefix));
    PUTBACK;
    bool retval = (bool)!!S_finish_callback_i64("starts_with");
    return retval;
}

bool
Cfish_Str_Starts_With_Utf8_OVERRIDE(cfish_String* self, const char* prefix, size_t size) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(prefix);
    CFISH_UNUSED_VAR(size);
    CFISH_THROW(CFISH_ERR, "Can't override CFISH_Str_Starts_With_Utf8 via binding");
    CFISH_UNREACHABLE_RETURN(bool);
}

bool
Cfish_Str_Ends_With_OVERRIDE(cfish_String* self, cfish_String* postfix) {
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    mPUSHs(XSBind_str_to_sv((cfish_String*)postfix));
    PUTBACK;
    bool retval = (bool)!!S_finish_callback_i64("ends_with");
    return retval;
}

bool
Cfish_Str_Ends_With_Utf8_OVERRIDE(cfish_String* self, const char* postfix, size_t size) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(postfix);
    CFISH_UNUSED_VAR(size);
    CFISH_THROW(CFISH_ERR, "Can't override CFISH_Str_Ends_With_Utf8 via binding");
    CFISH_UNREACHABLE_RETURN(bool);
}

int64_t
Cfish_Str_Find_OVERRIDE(cfish_String* self, cfish_String* substring) {
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    mPUSHs(XSBind_str_to_sv((cfish_String*)substring));
    PUTBACK;
    int64_t retval = (int64_t)S_finish_callback_i64("find");
    return retval;
}

int64_t
Cfish_Str_Find_Utf8_OVERRIDE(cfish_String* self, const char* ptr, size_t size) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(ptr);
    CFISH_UNUSED_VAR(size);
    CFISH_THROW(CFISH_ERR, "Can't override CFISH_Str_Find_Utf8 via binding");
    CFISH_UNREACHABLE_RETURN(int64_t);
}

bool
Cfish_Str_Equals_Utf8_OVERRIDE(cfish_String* self, const char* ptr, size_t size) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(ptr);
    CFISH_UNUSED_VAR(size);
    CFISH_THROW(CFISH_ERR, "Can't override CFISH_Str_Equals_Utf8 via binding");
    CFISH_UNREACHABLE_RETURN(bool);
}

size_t
Cfish_Str_Length_OVERRIDE(cfish_String* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    size_t retval = (size_t)S_finish_callback_i64("length");
    return retval;
}

size_t
Cfish_Str_Get_Size_OVERRIDE(cfish_String* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    size_t retval = (size_t)S_finish_callback_i64("get_size");
    return retval;
}

const char*
Cfish_Str_Get_Ptr8_OVERRIDE(cfish_String* self) {
    CFISH_UNUSED_VAR(self);
    CFISH_THROW(CFISH_ERR, "Can't override CFISH_Str_Get_Ptr8 via binding");
    CFISH_UNREACHABLE_RETURN(const char*);
}

char*
Cfish_Str_To_Utf8_OVERRIDE(cfish_String* self) {
    CFISH_UNUSED_VAR(self);
    CFISH_THROW(CFISH_ERR, "Can't override CFISH_Str_To_Utf8 via binding");
    CFISH_UNREACHABLE_RETURN(char*);
}

cfish_String*
Cfish_Str_Trim_OVERRIDE(cfish_String* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    cfish_String* retval = (cfish_String*)S_finish_callback_obj(self, "trim", false);
    CFISH_DECREF(retval);
    return retval;
}

cfish_String*
Cfish_Str_Trim_Top_OVERRIDE(cfish_String* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    cfish_String* retval = (cfish_String*)S_finish_callback_obj(self, "trim_top", false);
    CFISH_DECREF(retval);
    return retval;
}

cfish_String*
Cfish_Str_Trim_Tail_OVERRIDE(cfish_String* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    cfish_String* retval = (cfish_String*)S_finish_callback_obj(self, "trim_tail", false);
    CFISH_DECREF(retval);
    return retval;
}

int32_t
Cfish_Str_Code_Point_At_OVERRIDE(cfish_String* self, size_t tick) {
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    if (sizeof(IV) >= sizeof(size_t)) { mPUSHi(tick); }
    else { mPUSHn((double)tick); } // lossy 
    PUTBACK;
    int32_t retval = (int32_t)S_finish_callback_i64("code_point_at");
    return retval;
}

int32_t
Cfish_Str_Code_Point_From_OVERRIDE(cfish_String* self, size_t tick) {
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    if (sizeof(IV) >= sizeof(size_t)) { mPUSHi(tick); }
    else { mPUSHn((double)tick); } // lossy 
    PUTBACK;
    int32_t retval = (int32_t)S_finish_callback_i64("code_point_from");
    return retval;
}

cfish_String*
Cfish_Str_SubString_OVERRIDE(cfish_String* self, size_t offset, size_t len) {
    dSP;
    EXTEND(SP, 5);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    mPUSHp("offset", 6);
    if (sizeof(IV) >= sizeof(size_t)) { mPUSHi(offset); }
    else { mPUSHn((double)offset); } // lossy 
    mPUSHp("len", 3);
    if (sizeof(IV) >= sizeof(size_t)) { mPUSHi(len); }
    else { mPUSHn((double)len); } // lossy 
    PUTBACK;
    cfish_String* retval = (cfish_String*)S_finish_callback_obj(self, "substring", false);
    return retval;
}

cfish_StringIterator*
Cfish_Str_Top_OVERRIDE(cfish_String* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    cfish_StringIterator* retval = (cfish_StringIterator*)S_finish_callback_obj(self, "top", false);
    return retval;
}

cfish_StringIterator*
Cfish_Str_Tail_OVERRIDE(cfish_String* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    cfish_StringIterator* retval = (cfish_StringIterator*)S_finish_callback_obj(self, "tail", false);
    return retval;
}

cfish_StackStringIterator*
Cfish_Str_StackTop_OVERRIDE(cfish_String* self, void* allocation) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(allocation);
    CFISH_THROW(CFISH_ERR, "Can't override CFISH_Str_StackTop via binding");
    CFISH_UNREACHABLE_RETURN(cfish_StackStringIterator*);
}

cfish_StackStringIterator*
Cfish_Str_StackTail_OVERRIDE(cfish_String* self, void* allocation) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(allocation);
    CFISH_THROW(CFISH_ERR, "Can't override CFISH_Str_StackTail via binding");
    CFISH_UNREACHABLE_RETURN(cfish_StackStringIterator*);
}

void
Cfish_StrIter_Assign_OVERRIDE(cfish_StringIterator* self, cfish_StringIterator* other) {
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    mPUSHs(XSBind_str_to_sv((cfish_String*)other));
    PUTBACK;
    S_finish_callback_void("assign");
}

bool
Cfish_StrIter_Has_Next_OVERRIDE(cfish_StringIterator* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    bool retval = (bool)!!S_finish_callback_i64("has_next");
    return retval;
}

bool
Cfish_StrIter_Has_Prev_OVERRIDE(cfish_StringIterator* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    bool retval = (bool)!!S_finish_callback_i64("has_prev");
    return retval;
}

int32_t
Cfish_StrIter_Next_OVERRIDE(cfish_StringIterator* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    int32_t retval = (int32_t)S_finish_callback_i64("next");
    return retval;
}

int32_t
Cfish_StrIter_Prev_OVERRIDE(cfish_StringIterator* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    int32_t retval = (int32_t)S_finish_callback_i64("prev");
    return retval;
}

size_t
Cfish_StrIter_Advance_OVERRIDE(cfish_StringIterator* self, size_t num) {
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    if (sizeof(IV) >= sizeof(size_t)) { mPUSHi(num); }
    else { mPUSHn((double)num); } // lossy 
    PUTBACK;
    size_t retval = (size_t)S_finish_callback_i64("advance");
    return retval;
}

size_t
Cfish_StrIter_Recede_OVERRIDE(cfish_StringIterator* self, size_t num) {
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    if (sizeof(IV) >= sizeof(size_t)) { mPUSHi(num); }
    else { mPUSHn((double)num); } // lossy 
    PUTBACK;
    size_t retval = (size_t)S_finish_callback_i64("recede");
    return retval;
}

size_t
Cfish_StrIter_Skip_Next_Whitespace_OVERRIDE(cfish_StringIterator* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    size_t retval = (size_t)S_finish_callback_i64("skip_next_whitespace");
    return retval;
}

size_t
Cfish_StrIter_Skip_Prev_Whitespace_OVERRIDE(cfish_StringIterator* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    size_t retval = (size_t)S_finish_callback_i64("skip_prev_whitespace");
    return retval;
}

bool
Cfish_StrIter_Starts_With_OVERRIDE(cfish_StringIterator* self, cfish_String* prefix) {
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    mPUSHs(XSBind_str_to_sv((cfish_String*)prefix));
    PUTBACK;
    bool retval = (bool)!!S_finish_callback_i64("starts_with");
    return retval;
}

bool
Cfish_StrIter_Starts_With_Utf8_OVERRIDE(cfish_StringIterator* self, const char* prefix, size_t size) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(prefix);
    CFISH_UNUSED_VAR(size);
    CFISH_THROW(CFISH_ERR, "Can't override CFISH_StrIter_Starts_With_Utf8 via binding");
    CFISH_UNREACHABLE_RETURN(bool);
}

bool
Cfish_StrIter_Ends_With_OVERRIDE(cfish_StringIterator* self, cfish_String* postfix) {
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    mPUSHs(XSBind_str_to_sv((cfish_String*)postfix));
    PUTBACK;
    bool retval = (bool)!!S_finish_callback_i64("ends_with");
    return retval;
}

bool
Cfish_StrIter_Ends_With_Utf8_OVERRIDE(cfish_StringIterator* self, const char* postfix, size_t size) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(postfix);
    CFISH_UNUSED_VAR(size);
    CFISH_THROW(CFISH_ERR, "Can't override CFISH_StrIter_Ends_With_Utf8 via binding");
    CFISH_UNREACHABLE_RETURN(bool);
}

void
Cfish_Err_Cat_Mess_OVERRIDE(cfish_Err* self, cfish_String* mess) {
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    mPUSHs(XSBind_str_to_sv((cfish_String*)mess));
    PUTBACK;
    S_finish_callback_void("cat_mess");
}

cfish_String*
Cfish_Err_Get_Mess_OVERRIDE(cfish_Err* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    cfish_String* retval = (cfish_String*)S_finish_callback_obj(self, "get_mess", false);
    CFISH_DECREF(retval);
    return retval;
}

void
Cfish_Err_Add_Frame_OVERRIDE(cfish_Err* self, const char* file, int line, const char* func) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(file);
    CFISH_UNUSED_VAR(line);
    CFISH_UNUSED_VAR(func);
    CFISH_THROW(CFISH_ERR, "Can't override CFISH_Err_Add_Frame via binding");
}

cfish_String*
TestCfish_AliasTestObj_Aliased_OVERRIDE(testcfish_AliasTestObj* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    cfish_String* retval = (cfish_String*)S_finish_callback_obj(self, "perl_alias", false);
    return retval;
}

cfish_String*
TestCfish_AliasTestObj_Call_Aliased_From_C_OVERRIDE(testcfish_AliasTestObj* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    cfish_String* retval = (cfish_String*)S_finish_callback_obj(self, "call_aliased_from_c", false);
    return retval;
}

bool
Cfish_LFReg_Register_OVERRIDE(cfish_LockFreeRegistry* self, cfish_Obj* key, cfish_Obj* value) {
    dSP;
    EXTEND(SP, 5);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    mPUSHp("key", 3);
    mPUSHs(XSBind_cfish_to_perl((cfish_Obj*)key));
    mPUSHp("value", 5);
    mPUSHs(XSBind_cfish_to_perl((cfish_Obj*)value));
    PUTBACK;
    bool retval = (bool)!!S_finish_callback_i64("register");
    return retval;
}

cfish_Obj*
Cfish_LFReg_Fetch_OVERRIDE(cfish_LockFreeRegistry* self, cfish_Obj* key) {
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    mPUSHs(XSBind_cfish_to_perl((cfish_Obj*)key));
    PUTBACK;
    cfish_Obj* retval = (cfish_Obj*)S_finish_callback_obj(self, "fetch", true);
    CFISH_DECREF(retval);
    return retval;
}

void
Cfish_CB_Mimic_Utf8_OVERRIDE(cfish_CharBuf* self, const char* ptr, size_t size) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(ptr);
    CFISH_UNUSED_VAR(size);
    CFISH_THROW(CFISH_ERR, "Can't override CFISH_CB_Mimic_Utf8 via binding");
}

void
Cfish_CB_Cat_Utf8_OVERRIDE(cfish_CharBuf* self, const char* ptr, size_t size) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(ptr);
    CFISH_UNUSED_VAR(size);
    CFISH_THROW(CFISH_ERR, "Can't override CFISH_CB_Cat_Utf8 via binding");
}

void
Cfish_CB_Cat_Trusted_Utf8_OVERRIDE(cfish_CharBuf* self, const char* ptr, size_t size) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(ptr);
    CFISH_UNUSED_VAR(size);
    CFISH_THROW(CFISH_ERR, "Can't override CFISH_CB_Cat_Trusted_Utf8 via binding");
}

void
Cfish_CB_Cat_OVERRIDE(cfish_CharBuf* self, cfish_String* string) {
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    mPUSHs(XSBind_str_to_sv((cfish_String*)string));
    PUTBACK;
    S_finish_callback_void("cat");
}

void
Cfish_CB_VCatF_OVERRIDE(cfish_CharBuf* self, const char* pattern, va_list args) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(pattern);
    CFISH_UNUSED_VAR(args);
    CFISH_THROW(CFISH_ERR, "Can't override CFISH_CB_VCatF via binding");
}

void
Cfish_CB_Cat_Char_OVERRIDE(cfish_CharBuf* self, int32_t code_point) {
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    mPUSHi(code_point);
    PUTBACK;
    S_finish_callback_void("cat_char");
}

char*
Cfish_CB_Grow_OVERRIDE(cfish_CharBuf* self, size_t size) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(size);
    CFISH_THROW(CFISH_ERR, "Can't override CFISH_CB_Grow via binding");
    CFISH_UNREACHABLE_RETURN(char*);
}

void
Cfish_CB_Set_Size_OVERRIDE(cfish_CharBuf* self, size_t size) {
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    if (sizeof(IV) >= sizeof(size_t)) { mPUSHi(size); }
    else { mPUSHn((double)size); } // lossy 
    PUTBACK;
    S_finish_callback_void("set_size");
}

size_t
Cfish_CB_Get_Size_OVERRIDE(cfish_CharBuf* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    size_t retval = (size_t)S_finish_callback_i64("get_size");
    return retval;
}

char*
Cfish_CB_Get_Ptr8_OVERRIDE(cfish_CharBuf* self) {
    CFISH_UNUSED_VAR(self);
    CFISH_THROW(CFISH_ERR, "Can't override CFISH_CB_Get_Ptr8 via binding");
    CFISH_UNREACHABLE_RETURN(char*);
}

cfish_String*
Cfish_CB_Yield_String_OVERRIDE(cfish_CharBuf* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    cfish_String* retval = (cfish_String*)S_finish_callback_obj(self, "yield_string", false);
    return retval;
}

void
Cfish_VA_Push_OVERRIDE(cfish_VArray* self, cfish_Obj* element) {
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    mPUSHs(XSBind_cfish_to_perl((cfish_Obj*)element));
    PUTBACK;
    S_finish_callback_void("push");
    CFISH_DECREF(element);
}

void
Cfish_VA_Push_VArray_OVERRIDE(cfish_VArray* self, cfish_VArray* other) {
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    mPUSHs(XSBind_cfish_to_perl((cfish_Obj*)other));
    PUTBACK;
    S_finish_callback_void("push_varray");
}

cfish_Obj*
Cfish_VA_Pop_OVERRIDE(cfish_VArray* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    cfish_Obj* retval = (cfish_Obj*)S_finish_callback_obj(self, "pop", true);
    return retval;
}

void
Cfish_VA_Unshift_OVERRIDE(cfish_VArray* self, cfish_Obj* element) {
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    mPUSHs(XSBind_cfish_to_perl((cfish_Obj*)element));
    PUTBACK;
    S_finish_callback_void("unshift");
    CFISH_DECREF(element);
}

cfish_Obj*
Cfish_VA_Shift_OVERRIDE(cfish_VArray* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    cfish_Obj* retval = (cfish_Obj*)S_finish_callback_obj(self, "shift", true);
    return retval;
}

void
Cfish_VA_Grow_OVERRIDE(cfish_VArray* self, uint32_t capacity) {
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    mPUSHi(capacity);
    PUTBACK;
    S_finish_callback_void("grow");
}

cfish_Obj*
Cfish_VA_Fetch_OVERRIDE(cfish_VArray* self, uint32_t tick) {
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    mPUSHi(tick);
    PUTBACK;
    cfish_Obj* retval = (cfish_Obj*)S_finish_callback_obj(self, "fetch", true);
    CFISH_DECREF(retval);
    return retval;
}

void
Cfish_VA_Store_OVERRIDE(cfish_VArray* self, uint32_t tick, cfish_Obj* elem) {
    dSP;
    EXTEND(SP, 5);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    mPUSHp("tick", 4);
    mPUSHi(tick);
    mPUSHp("elem", 4);
    mPUSHs(XSBind_cfish_to_perl((cfish_Obj*)elem));
    PUTBACK;
    S_finish_callback_void("store");
    CFISH_DECREF(elem);
}

cfish_Obj*
Cfish_VA_Delete_OVERRIDE(cfish_VArray* self, uint32_t tick) {
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    mPUSHi(tick);
    PUTBACK;
    cfish_Obj* retval = (cfish_Obj*)S_finish_callback_obj(self, "delete", true);
    return retval;
}

void
Cfish_VA_Excise_OVERRIDE(cfish_VArray* self, uint32_t offset, uint32_t length) {
    dSP;
    EXTEND(SP, 5);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    mPUSHp("offset", 6);
    mPUSHi(offset);
    mPUSHp("length", 6);
    mPUSHi(length);
    PUTBACK;
    S_finish_callback_void("excise");
}

cfish_VArray*
Cfish_VA_Shallow_Copy_OVERRIDE(cfish_VArray* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    cfish_VArray* retval = (cfish_VArray*)S_finish_callback_obj(self, "shallow_copy", false);
    return retval;
}

void
Cfish_VA_Sort_OVERRIDE(cfish_VArray* self, CFISH_Sort_Compare_t compare, void* context) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(compare);
    CFISH_UNUSED_VAR(context);
    CFISH_THROW(CFISH_ERR, "Can't override CFISH_VA_Sort via binding");
}

void
Cfish_VA_Resize_OVERRIDE(cfish_VArray* self, uint32_t size) {
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    mPUSHi(size);
    PUTBACK;
    S_finish_callback_void("resize");
}

void
Cfish_VA_Clear_OVERRIDE(cfish_VArray* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    S_finish_callback_void("clear");
}

uint32_t
Cfish_VA_Get_Size_OVERRIDE(cfish_VArray* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    uint32_t retval = (uint32_t)S_finish_callback_i64("get_size");
    return retval;
}

uint32_t
Cfish_VA_Get_Capacity_OVERRIDE(cfish_VArray* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    uint32_t retval = (uint32_t)S_finish_callback_i64("get_capacity");
    return retval;
}

cfish_VArray*
Cfish_VA_Gather_OVERRIDE(cfish_VArray* self, CFISH_VA_Gather_Test_t test, void* data) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(test);
    CFISH_UNUSED_VAR(data);
    CFISH_THROW(CFISH_ERR, "Can't override CFISH_VA_Gather via binding");
    CFISH_UNREACHABLE_RETURN(cfish_VArray*);
}

cfish_VArray*
Cfish_VA_Slice_OVERRIDE(cfish_VArray* self, uint32_t offset, uint32_t length) {
    dSP;
    EXTEND(SP, 5);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    mPUSHp("offset", 6);
    mPUSHi(offset);
    mPUSHp("length", 6);
    mPUSHi(length);
    PUTBACK;
    cfish_VArray* retval = (cfish_VArray*)S_finish_callback_obj(self, "slice", false);
    return retval;
}

cfish_String*
Cfish_Method_Get_Name_OVERRIDE(cfish_Method* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    cfish_String* retval = (cfish_String*)S_finish_callback_obj(self, "get_name", false);
    CFISH_DECREF(retval);
    return retval;
}

cfish_String*
Cfish_Method_Get_Host_Alias_OVERRIDE(cfish_Method* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    cfish_String* retval = (cfish_String*)S_finish_callback_obj(self, "get_host_alias", true);
    CFISH_DECREF(retval);
    return retval;
}

bool
Cfish_Method_Is_Excluded_From_Host_OVERRIDE(cfish_Method* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    bool retval = (bool)!!S_finish_callback_i64("is_excluded_from_host");
    return retval;
}

cfish_String*
Cfish_Method_Host_Name_OVERRIDE(cfish_Method* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    cfish_String* retval = (cfish_String*)S_finish_callback_obj(self, "host_name", false);
    return retval;
}

void
Cfish_BB_Set_Size_OVERRIDE(cfish_ByteBuf* self, size_t size) {
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    if (sizeof(IV) >= sizeof(size_t)) { mPUSHi(size); }
    else { mPUSHn((double)size); } // lossy 
    PUTBACK;
    S_finish_callback_void("set_size");
}

size_t
Cfish_BB_Get_Size_OVERRIDE(cfish_ByteBuf* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    size_t retval = (size_t)S_finish_callback_i64("get_size");
    return retval;
}

char*
Cfish_BB_Get_Buf_OVERRIDE(cfish_ByteBuf* self) {
    CFISH_UNUSED_VAR(self);
    CFISH_THROW(CFISH_ERR, "Can't override CFISH_BB_Get_Buf via binding");
    CFISH_UNREACHABLE_RETURN(char*);
}

size_t
Cfish_BB_Get_Capacity_OVERRIDE(cfish_ByteBuf* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    size_t retval = (size_t)S_finish_callback_i64("get_capacity");
    return retval;
}

void
Cfish_BB_Mimic_Bytes_OVERRIDE(cfish_ByteBuf* self, const void* bytes, size_t size) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(bytes);
    CFISH_UNUSED_VAR(size);
    CFISH_THROW(CFISH_ERR, "Can't override CFISH_BB_Mimic_Bytes via binding");
}

void
Cfish_BB_Cat_Bytes_OVERRIDE(cfish_ByteBuf* self, const void* bytes, size_t size) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(bytes);
    CFISH_UNUSED_VAR(size);
    CFISH_THROW(CFISH_ERR, "Can't override CFISH_BB_Cat_Bytes via binding");
}

void
Cfish_BB_Cat_OVERRIDE(cfish_ByteBuf* self, cfish_ByteBuf* other) {
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    mPUSHs(XSBind_cfish_to_perl((cfish_Obj*)other));
    PUTBACK;
    S_finish_callback_void("cat");
}

char*
Cfish_BB_Grow_OVERRIDE(cfish_ByteBuf* self, size_t size) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(size);
    CFISH_THROW(CFISH_ERR, "Can't override CFISH_BB_Grow via binding");
    CFISH_UNREACHABLE_RETURN(char*);
}

bool
Cfish_BB_Equals_Bytes_OVERRIDE(cfish_ByteBuf* self, const void* bytes, size_t size) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(bytes);
    CFISH_UNUSED_VAR(size);
    CFISH_THROW(CFISH_ERR, "Can't override CFISH_BB_Equals_Bytes via binding");
    CFISH_UNREACHABLE_RETURN(bool);
}

void
Cfish_ViewBB_Assign_Bytes_OVERRIDE(cfish_ViewByteBuf* self, char* buf, size_t size) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(buf);
    CFISH_UNUSED_VAR(size);
    CFISH_THROW(CFISH_ERR, "Can't override CFISH_ViewBB_Assign_Bytes via binding");
}

void
Cfish_ViewBB_Assign_OVERRIDE(cfish_ViewByteBuf* self, cfish_ByteBuf* other) {
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    mPUSHs(XSBind_cfish_to_perl((cfish_Obj*)other));
    PUTBACK;
    S_finish_callback_void("assign");
}

void
Cfish_Hash_Clear_OVERRIDE(cfish_Hash* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    S_finish_callback_void("clear");
}

void
Cfish_Hash_Store_OVERRIDE(cfish_Hash* self, cfish_Obj* key, cfish_Obj* value) {
    dSP;
    EXTEND(SP, 5);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    mPUSHp("key", 3);
    mPUSHs(XSBind_cfish_to_perl((cfish_Obj*)key));
    mPUSHp("value", 5);
    mPUSHs(XSBind_cfish_to_perl((cfish_Obj*)value));
    PUTBACK;
    S_finish_callback_void("store");
    CFISH_DECREF(value);
}

void
Cfish_Hash_Store_Utf8_OVERRIDE(cfish_Hash* self, const char* str, size_t len, cfish_Obj* value) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(str);
    CFISH_UNUSED_VAR(len);
    CFISH_UNUSED_VAR(value);
    CFISH_THROW(CFISH_ERR, "Can't override CFISH_Hash_Store_Utf8 via binding");
}

cfish_Obj*
Cfish_Hash_Fetch_OVERRIDE(cfish_Hash* self, cfish_Obj* key) {
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    mPUSHs(XSBind_cfish_to_perl((cfish_Obj*)key));
    PUTBACK;
    cfish_Obj* retval = (cfish_Obj*)S_finish_callback_obj(self, "fetch", true);
    CFISH_DECREF(retval);
    return retval;
}

cfish_Obj*
Cfish_Hash_Fetch_Utf8_OVERRIDE(cfish_Hash* self, const char* key, size_t key_len) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(key);
    CFISH_UNUSED_VAR(key_len);
    CFISH_THROW(CFISH_ERR, "Can't override CFISH_Hash_Fetch_Utf8 via binding");
    CFISH_UNREACHABLE_RETURN(cfish_Obj*);
}

cfish_Obj*
Cfish_Hash_Delete_OVERRIDE(cfish_Hash* self, cfish_Obj* key) {
    dSP;
    EXTEND(SP, 2);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    mPUSHs(XSBind_cfish_to_perl((cfish_Obj*)key));
    PUTBACK;
    cfish_Obj* retval = (cfish_Obj*)S_finish_callback_obj(self, "delete", true);
    return retval;
}

cfish_Obj*
Cfish_Hash_Delete_Utf8_OVERRIDE(cfish_Hash* self, const char* key, size_t key_ley) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(key);
    CFISH_UNUSED_VAR(key_ley);
    CFISH_THROW(CFISH_ERR, "Can't override CFISH_Hash_Delete_Utf8 via binding");
    CFISH_UNREACHABLE_RETURN(cfish_Obj*);
}

uint32_t
Cfish_Hash_Iterate_OVERRIDE(cfish_Hash* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    uint32_t retval = (uint32_t)S_finish_callback_i64("iterate");
    return retval;
}

bool
Cfish_Hash_Next_OVERRIDE(cfish_Hash* self, cfish_Obj** key, cfish_Obj** value) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(key);
    CFISH_UNUSED_VAR(value);
    CFISH_THROW(CFISH_ERR, "Can't override CFISH_Hash_Next via binding");
    CFISH_UNREACHABLE_RETURN(bool);
}

cfish_Obj*
Cfish_Hash_Find_Key_OVERRIDE(cfish_Hash* self, cfish_Obj* key, int32_t hash_sum) {
    dSP;
    EXTEND(SP, 5);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    mPUSHp("key", 3);
    mPUSHs(XSBind_cfish_to_perl((cfish_Obj*)key));
    mPUSHp("hash_sum", 8);
    mPUSHi(hash_sum);
    PUTBACK;
    cfish_Obj* retval = (cfish_Obj*)S_finish_callback_obj(self, "find_key", true);
    CFISH_DECREF(retval);
    return retval;
}

cfish_VArray*
Cfish_Hash_Keys_OVERRIDE(cfish_Hash* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    cfish_VArray* retval = (cfish_VArray*)S_finish_callback_obj(self, "keys", false);
    return retval;
}

cfish_VArray*
Cfish_Hash_Values_OVERRIDE(cfish_Hash* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    cfish_VArray* retval = (cfish_VArray*)S_finish_callback_obj(self, "values", false);
    return retval;
}

cfish_Obj*
Cfish_Hash_Make_Key_OVERRIDE(cfish_Hash* self, cfish_Obj* key, int32_t hash_sum) {
    dSP;
    EXTEND(SP, 5);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    mPUSHp("key", 3);
    mPUSHs(XSBind_cfish_to_perl((cfish_Obj*)key));
    mPUSHp("hash_sum", 8);
    mPUSHi(hash_sum);
    PUTBACK;
    cfish_Obj* retval = (cfish_Obj*)S_finish_callback_obj(self, "make_key", false);
    return retval;
}

uint32_t
Cfish_Hash_Get_Capacity_OVERRIDE(cfish_Hash* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    uint32_t retval = (uint32_t)S_finish_callback_i64("get_capacity");
    return retval;
}

uint32_t
Cfish_Hash_Get_Size_OVERRIDE(cfish_Hash* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    uint32_t retval = (uint32_t)S_finish_callback_i64("get_size");
    return retval;
}

void
Cfish_Class_Override_OVERRIDE(cfish_Class* self, cfish_method_t method_ptr, size_t offset) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(method_ptr);
    CFISH_UNUSED_VAR(offset);
    CFISH_THROW(CFISH_ERR, "Can't override CFISH_Class_Override via binding");
}

cfish_Obj*
Cfish_Class_Make_Obj_OVERRIDE(cfish_Class* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    cfish_Obj* retval = (cfish_Obj*)S_finish_callback_obj(self, "make_obj", false);
    return retval;
}

cfish_Obj*
Cfish_Class_Init_Obj_OVERRIDE(cfish_Class* self, void* allocation) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(allocation);
    CFISH_THROW(CFISH_ERR, "Can't override CFISH_Class_Init_Obj via binding");
    CFISH_UNREACHABLE_RETURN(cfish_Obj*);
}

cfish_Obj*
Cfish_Class_Foster_Obj_OVERRIDE(cfish_Class* self, void* host_obj) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(host_obj);
    CFISH_THROW(CFISH_ERR, "Can't override CFISH_Class_Foster_Obj via binding");
    CFISH_UNREACHABLE_RETURN(cfish_Obj*);
}

void
Cfish_Class_Add_Host_Method_Alias_OVERRIDE(cfish_Class* self, const char* alias, const char* meth_name) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(alias);
    CFISH_UNUSED_VAR(meth_name);
    CFISH_THROW(CFISH_ERR, "Can't override CFISH_Class_Add_Host_Method_Alias via binding");
}

void
Cfish_Class_Exclude_Host_Method_OVERRIDE(cfish_Class* self, const char* meth_name) {
    CFISH_UNUSED_VAR(self);
    CFISH_UNUSED_VAR(meth_name);
    CFISH_THROW(CFISH_ERR, "Can't override CFISH_Class_Exclude_Host_Method via binding");
}

cfish_String*
Cfish_Class_Get_Name_OVERRIDE(cfish_Class* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    cfish_String* retval = (cfish_String*)S_finish_callback_obj(self, "get_name", false);
    CFISH_DECREF(retval);
    return retval;
}

cfish_Class*
Cfish_Class_Get_Parent_OVERRIDE(cfish_Class* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    cfish_Class* retval = (cfish_Class*)S_finish_callback_obj(self, "get_parent", false);
    CFISH_DECREF(retval);
    return retval;
}

size_t
Cfish_Class_Get_Obj_Alloc_Size_OVERRIDE(cfish_Class* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    size_t retval = (size_t)S_finish_callback_i64("get_obj_alloc_size");
    return retval;
}

cfish_VArray*
Cfish_Class_Get_Methods_OVERRIDE(cfish_Class* self) {
    dSP;
    EXTEND(SP, 1);
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    mPUSHs((SV*)CFISH_Obj_To_Host((cfish_Obj*)self));
    PUTBACK;
    cfish_VArray* retval = (cfish_VArray*)S_finish_callback_obj(self, "get_methods", false);
    CFISH_DECREF(retval);
    return retval;
}

